//
// Copyright (C) 2020 The Android Open Source Project
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// clang-format off
#include "native_bridge_support/vdso/interceptable_functions.h"

DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmapConfig_getConfigFromFormat);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmapConfig_getFormatFromConfig);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_acquireBitmapFromJava);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_acquireRef);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_compress);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_copy);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_getDataSpace);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_getInfo);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_getInfoFromJava);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_getPixels);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_notifyPixelsChanged);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ABitmap_releaseRef);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_clipOutRect);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_clipRect);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_createCanvas);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_destroyCanvas);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_drawBitmap);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_drawRect);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_getNativeHandleFromJava);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_isSupportedPixelFormat);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ACanvas_setBuffer);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(AMatrix_getContents);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(APaint_createPaint);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(APaint_destroyPaint);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(APaint_setBlendMode);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ARegionIterator_acquireIterator);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ARegionIterator_getRect);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ARegionIterator_getTotalBounds);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ARegionIterator_isComplex);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ARegionIterator_isDone);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ARegionIterator_next);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ARegionIterator_releaseIterator);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(ARenderThread_dumpGraphicsMemory);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifCloseFile);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifExtensionToGCB);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetCode);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetCodeNext);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetExtension);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetExtensionNext);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetImageDesc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetLZCodes);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetLine);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetPixel);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetRecordType);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifGetScreenDesc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifOpen);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifOpenFileHandle);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifOpenFileName);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifSavedExtensionToGCB);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(DGifSlurp);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(FreeLastSavedImage);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifAddExtensionBlock);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifApplyTranslation);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifBitSize);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifFreeExtensions);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifFreeMapObject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifFreeSavedImages);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifMakeMapObject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifMakeSavedImage);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(GifUnionColorMap);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z10doThrowIAEP7_JNIEnvPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z10doThrowIOEP7_JNIEnvPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z10doThrowISEP7_JNIEnvPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z10doThrowNPEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z10error_exitP18jpeg_common_struct);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z10getContextx);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z11doThrowOOMEP7_JNIEnvPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z11getMimeType20SkEncodedImageFormat);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z12checkGlErrorP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z13create_jmovieP7_JNIEnvP5Movie);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z13doThrowAIOOBEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z17get_native_cameraP7_JNIEnvP8_jobjectPP16JNICameraContext);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z19CopyJavaInputStreamP7_JNIEnvP8_jobjectP11_jbyteArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z19_set_seccomp_filter10FilterType);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z21postProcessAndReleaseP7_JNIEnvP8_jobjectNSt3__110unique_ptrIN7android6CanvasENS3_14default_deleteIS6_EEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z22get_device_from_objectP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z22set_app_seccomp_filterv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z23getMimeTypeAsJavaStringP7_JNIEnv20SkEncodedImageFormat);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z23get_request_from_objectP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z25_install_setuidgid_filterjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z25android_os_Process_setGidP7_JNIEnvP8_jobjecti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z25android_os_Process_setUidP7_JNIEnvP8_jobjecti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z25set_system_seccomp_filterv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z26android_os_Process_getPidsP7_JNIEnvP8_jobjectP8_jstringP10_jintArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z26get_exclusive_cpuset_cores11SchedPolicyP9cpu_set_t);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z26register_android_os_BinderP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z27android_os_Process_setArgV0P7_JNIEnvP8_jobjectP8_jstring);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z27register_android_media_midiP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z27register_android_os_ProcessP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z28CreateByteArrayStreamAdaptorP7_JNIEnvP11_jbyteArrayjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z28CreateJavaInputStreamAdaptorP7_JNIEnvP8_jobjectP11_jbyteArrayb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z29CreateByteBufferStreamAdaptorP7_JNIEnvP8_jobjectjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z29CreateJavaOutputStreamAdaptorP7_JNIEnvP8_jobjectP11_jbyteArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z29android_os_Process_sendSignalP7_JNIEnvP8_jobjectii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z29set_app_zygote_seccomp_filterv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z31android_os_Process_readProcFileP7_JNIEnvP8_jobjectP8_jstringP10_jintArrayP13_jobjectArrayP11_jlongArrayP12_jfloatArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z31register_android_graphics_MovieP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32android_os_Process_getGidForNameP7_JNIEnvP8_jobjectP8_jstring);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32android_os_Process_getUidForNameP7_JNIEnvP8_jobjectP8_jstring);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32android_os_Process_parseProcLineP7_JNIEnvP8_jobjectP11_jbyteArrayiiP10_jintArrayP13_jobjectArrayP11_jlongArrayP12_jfloatArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32android_os_Process_readProcLinesP7_JNIEnvP8_jobjectP8_jstringP13_jobjectArrayP11_jlongArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32android_os_Process_setSwappinessP7_JNIEnvP8_jobjectih);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32install_setuidgid_seccomp_filterjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32register_android_graphics_BitmapP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32register_android_graphics_CameraP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32register_android_graphics_ShaderP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z32register_android_hardware_CameraP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z33android_os_Process_setThreadGroupP7_JNIEnvP8_jobjectii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z33register_android_media_AudioTrackP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z33register_android_opengl_jni_EGL14P7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z33register_android_opengl_jni_EGL15P7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34JHwBinder_native_joinRpcThreadpoolv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34android_os_Process_getProcessGroupP7_JNIEnvP8_jobjecti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34android_os_Process_sendSignalQuietP7_JNIEnvP8_jobjectii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34android_os_Process_setProcessGroupP7_JNIEnvP8_jobjectii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_graphics_GraphicsP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_graphics_TypefaceP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_graphics_YuvImageP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_media_AudioRecordP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_media_AudioSystemP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_opengl_jni_EGLExtP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_opengl_jni_GLES10P7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_opengl_jni_GLES11P7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_opengl_jni_GLES20P7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_opengl_jni_GLES30P7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_opengl_jni_GLES31P7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z34register_android_opengl_jni_GLES32P7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z35android_os_Process_killProcessGroupP7_JNIEnvP8_jobjectii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z35register_android_graphics_NinePatchP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z35register_android_hardware_UsbDeviceP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36android_os_Binder_getNativeFinalizerP7_JNIEnvP7_jclass);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36android_os_Process_getExclusiveCoresP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36android_os_Process_getThreadPriorityP7_JNIEnvP8_jobjecti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36android_os_Process_setThreadPriorityP7_JNIEnvP8_jobjectii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36register_android_graphics_MaskFilterP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36register_android_graphics_PathEffectP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36register_android_hardware_SerialPortP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36register_android_hardware_UsbRequestP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z36register_android_media_ToneGeneratorP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37android_media_getIntConstantFromClassP7_JNIEnvP7_jclassPKcS4_Pi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37android_os_Process_getPidsForCommandsP7_JNIEnvP8_jobjectP13_jobjectArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37android_os_Process_getThreadSchedulerP7_JNIEnvP7_jclassi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37android_os_Process_parseProcLineArrayP7_JNIEnvP8_jobjectPciiP10_jintArrayP13_jobjectArrayP11_jlongArrayP12_jfloatArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37android_os_Process_setThreadSchedulerP7_JNIEnvP7_jclassiii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37register_android_media_MicrophoneInfoP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37register_android_opengl_jni_GLES10ExtP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37register_android_opengl_jni_GLES11ExtP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z37register_android_opengl_jni_GLES31ExtP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z38android_media_AudioTrack_getAudioTrackP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z38register_android_graphics_ImageDecoderP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z38register_android_graphics_InterpolatorP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z38register_android_media_AudioAttributesP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z39JHwBinder_native_configureRpcThreadpoolP7_JNIEnvP7_jclassxh);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z39android_os_Process_setApplicationObjectP7_JNIEnvP8_jobjectS2_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z39register_android_graphics_BitmapFactoryP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z39register_android_graphics_GraphicBufferP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z39register_android_hardware_SensorManagerP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z40register_android_hardware_HardwareBufferP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z40register_android_media_AudioVolumeGroupsP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z41android_os_BinderProxy_getNativeFinalizerP7_JNIEnvP7_jclass);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z41android_os_Process_removeAllProcessGroupsP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z41register_android_media_AudioDeviceAddressP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z42android_os_Process_setThreadGroupAndCpusetP7_JNIEnvP8_jobjectii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z43android_os_Process_setCallingThreadPriorityP7_JNIEnvP8_jobjecti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z43register_com_google_android_gles_jni_GLImplP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z44register_android_hardware_camera2_DngCreatorP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z44register_android_media_AudioEffectDescriptorP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z44register_com_google_android_gles_jni_EGLImplP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z45register_android_graphics_BitmapRegionDecoderP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z45register_android_hardware_UsbDeviceConnectionP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z45register_android_media_AudioProductStrategiesP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z48register_android_hardware_camera2_CameraMetadataP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z49register_android_graphics_ByteBufferStreamAdaptorP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z52register_android_media_AudioVolumeGroupChangeHandlerP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z55register_android_graphics_CreateJavaOutputStreamAdaptorP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z56register_android_graphics_drawable_AnimatedImageDrawableP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z56register_android_hardware_camera2_legacy_PerfMeasurementP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z59register_android_hardware_camera2_legacy_LegacyCameraDeviceP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z62register_android_hardware_location_ActivityRecognitionHardwareP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_Z9doThrowREP7_JNIEnvPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI12createRegionEP7_JNIEnvP8SkRegion);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI12hasExceptionEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI13getBitmapInfoEP7_JNIEnvP8_jobjectPj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI13getColorSpaceEP7_JNIEnvP12SkColorSpace11SkColorType);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI13jrect_to_rectEP7_JNIEnvP8_jobjectP6SkRect);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI14irect_to_jrectERK7SkIRectP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI14jrect_to_irectEP7_JNIEnvP8_jobjectP7SkIRect);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI14jrectf_to_rectEP7_JNIEnvP8_jobjectP6SkRect);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI14rect_to_jrectfERK6SkRectP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI15getNativeBitmapEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI15getNativeCanvasEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI15getNativeRegionEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI16convertColorLongEx);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI16ipoint_to_jpointERK8SkIPointP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI16isHardwareConfigEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI16jpoint_to_ipointEP7_JNIEnvP8_jobjectP8SkIPoint);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI16jpointf_to_pointEP7_JNIEnvP8_jobjectP7SkPoint);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI16point_to_jpointfERK7SkPointP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI19getConfigFromFormatEP7_JNIEnv19AndroidBitmapFormat);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI19getFormatFromConfigEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI19getNativeColorSpaceEx);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI24getNativeBitmapColorTypeEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI25createBitmapRegionDecoderEP7_JNIEnvP21SkBitmapRegionDecoder);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI26hardwareLegacyBitmapConfigEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI29colorTypeToLegacyBitmapConfigE11SkColorType);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI29legacyBitmapConfigToColorTypeEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI9SetPixelsEP7_JNIEnvP10_jintArrayiiiiiiP8SkBitmap);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI9get_jrectEP7_JNIEnvP8_jobjectPiS4_S4_S4_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN11GraphicsJNI9set_jrectEP7_JNIEnvP8_jobjectiiii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13HeapAllocator13allocPixelRefEP8SkBitmap);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContext10setGpsDataERK7GpsData);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContext12setThumbnailEPKhjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContext14setCaptureTimeERKN7android7String8E);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContext14setDescriptionERKN7android7String8E);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContext14setOrientationEt);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContext9getWriterEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContextC2ERKN7android14CameraMetadataES3_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContextD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN13NativeContextD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN14JniInputStream4openEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN14JniInputStream4readEPhjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN14JniInputStream4skipEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN14JniInputStream5closeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN14JniInputStreamC2EP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN14JniInputStreamD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN14JniInputStreamD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN15JniOutputStream4openEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN15JniOutputStream5closeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN15JniOutputStream5writeEPKhjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN15JniOutputStreamC2EP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN15JniOutputStreamD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN15JniOutputStreamD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN15NinePatchPeeker5scaleEffii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN15NinePatchPeeker9readChunkEPKcPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16AutoJavaIntArrayC2EP7_JNIEnvP10_jintArrayi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16AutoJavaIntArrayD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16InputStripSource13writeToStreamERN7android9img_utils6OutputEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16InputStripSourceC2EP7_JNIEnvRN7android9img_utils5InputEjjjjjyjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16InputStripSourceD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16InputStripSourceD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext11copyAndPostEP7_JNIEnvRKN7android2spINS2_7IMemoryEEEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext12postMetadataEP7_JNIEnviP21camera_frame_metadata);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext15setCallbackModeEP7_JNIEnvbb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext17addCallbackBufferEP7_JNIEnvP11_jbyteArrayi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext17getCallbackBufferEP7_JNIEnvPN7android6VectorIP11_jbyteArrayEEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext17postDataTimestampExiRKN7android2spINS0_7IMemoryEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext22clearCallbackBuffers_lEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext22clearCallbackBuffers_lEP7_JNIEnvPN7android6VectorIP11_jbyteArrayEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext33postRecordingFrameHandleTimestampExP13native_handle);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext38postRecordingFrameHandleTimestampBatchERKNSt3__16vectorIxNS0_9allocatorIxEEEERKNS1_IP13native_handleNS2_IS8_EEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext6notifyEiii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext7releaseEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContext8postDataEiRKN7android2spINS0_7IMemoryEEEP21camera_frame_metadata);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContextC1EP7_JNIEnvP8_jobjectP7_jclassRKN7android2spINS6_6CameraEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16JNICameraContextC2EP7_JNIEnvP8_jobjectP7_jclassRKN7android2spINS6_6CameraEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16YuvToJpegEncoder21setJpegCompressStructEP20jpeg_compress_structiii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16YuvToJpegEncoder6createEiPi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16YuvToJpegEncoder6encodeEP9SkWStreamPviiPii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN16YuvToJpegEncoderC2EPi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN17AutoJavaByteArrayC2EP7_JNIEnvP11_jbyteArrayi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN17AutoJavaByteArrayD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN17DirectStripSource13writeToStreamERN7android9img_utils6OutputEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN17DirectStripSourceC2EP7_JNIEnvPKhjjjjjyjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN17DirectStripSourceD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN17DirectStripSourceD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18AutoJavaFloatArrayC2EP7_JNIEnvP12_jfloatArrayi9JNIAccess);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18AutoJavaFloatArrayD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18AutoJavaShortArrayC2EP7_JNIEnvP12_jshortArrayi9JNIAccess);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18AutoJavaShortArrayD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18DeathRecipientList3addERKN7android2spI18JavaDeathRecipientEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18DeathRecipientList4findEP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18DeathRecipientList4lockEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18DeathRecipientList6removeERKN7android2spI18JavaDeathRecipientEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18DeathRecipientListC2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18DeathRecipientListD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18DeathRecipientListD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18FileDescriptorInfo12CreateFromFdEiRKNSt3__18functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18FileDescriptorInfo13GetSocketNameEiPNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18FileDescriptorInfoC2E4statRKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEiiiil);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18FileDescriptorInfoC2Ei);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18JniInputByteBuffer4openEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18JniInputByteBuffer4readEPhjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18JniInputByteBuffer5closeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18JniInputByteBufferC2EP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18JniInputByteBufferD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN18JniInputByteBufferD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN19FileDescriptorTable14ReopenOrDetachERKNSt3__18functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN19FileDescriptorTable14RestatInternalERNSt3__13setIiNS0_4lessIiEENS0_9allocatorIiEEEERKNS0_8functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS4_IcEEEEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN19FileDescriptorTable6CreateERKNSt3__16vectorIiNS0_9allocatorIiEEEERKNS0_8functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS2_IcEEEEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN19FileDescriptorTable6RestatERKNSt3__16vectorIiNS0_9allocatorIiEEEERKNS0_8functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS2_IcEEEEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN19FileDescriptorTable7ParseFdEP6direnti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN19FileDescriptorTableC2ERKNSt3__113unordered_mapIiP18FileDescriptorInfoNS0_4hashIiEENS0_8equal_toIiEENS0_9allocatorINS0_4pairIKiS3_EEEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20AshmemPixelAllocator13allocPixelRefEP8SkBitmap);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20AshmemPixelAllocatorC2EP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20JNIAudioPortCallback13onServiceDiedEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20JNIAudioPortCallback21onAudioPortListUpdateEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20JNIAudioPortCallback22onAudioPatchListUpdateEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20JNIAudioPortCallback9sendEventEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20JNIAudioPortCallbackC2EP7_JNIEnvP8_jobjectS3_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20JNIAudioPortCallbackD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20JNIAudioPortCallbackD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20Yuv422IToJpegEncoder12deinterleaveEPhS0_S0_S0_iii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20Yuv422IToJpegEncoder21configSamplingFactorsEP20jpeg_compress_struct);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20Yuv422IToJpegEncoder8compressEP20jpeg_compress_structPhPi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN20Yuv422IToJpegEncoderC2EPi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN21Yuv420SpToJpegEncoder12deinterleaveEPhS0_S0_iii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN21Yuv420SpToJpegEncoder21configSamplingFactorsEP20jpeg_compress_struct);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN21Yuv420SpToJpegEncoder8compressEP20jpeg_compress_structPhPi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN21Yuv420SpToJpegEncoderC2EPi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN23FileDescriptorWhitelist3GetEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN23FileDescriptorWhitelistC2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN31RecyclingClippingPixelAllocator13allocPixelRefEP8SkBitmap);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN31RecyclingClippingPixelAllocator15copyIfNecessaryEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN31RecyclingClippingPixelAllocatorC2EPN7android6BitmapEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN31RecyclingClippingPixelAllocatorD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN31RecyclingClippingPixelAllocatorD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie10DecodeFileEPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie10ensureInfoEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie12DecodeMemoryEPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie12DecodeStreamEP18SkStreamRewindable);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie5widthEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie6bitmapEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie6heightEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie7setTimeEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie8durationEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5Movie8isOpaqueEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN5MovieC2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue11createQueueEP8_jobjectRKNS_2spINS_6LooperEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue11finishEventEPNS_10InputEventEb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue12attachLooperEPNS_6LooperEiPFiiiPvES3_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue12detachLooperEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue12enqueueEventEPNS_10InputEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue13handleMessageERKNS_7MessageE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue14createKeyEventEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue16preDispatchEventEPNS_10InputEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue17createMotionEventEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue17recycleInputEventEPNS_10InputEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue18detachLooperLockedEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue8getEventEPPNS_10InputEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueue9hasEventsEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueueC1EP8_jobjectRKNS_2spINS_6LooperEEEii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueueC2EP8_jobjectRKNS_2spINS_6LooperEEEii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueueD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueueD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10InputQueueD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10dmabufinfo14ReadDmaBufInfoEPNSt3__16vectorINS0_9DmaBufferENS1_9allocatorIS3_EEEERKNS1_12basic_stringIcNS1_11char_traitsIcEENS4_IcEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10dmabufinfo14ReadDmaBufInfoEiPNSt3__16vectorINS0_9DmaBufferENS1_9allocatorIS3_EEEEb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10dmabufinfo16AppendDmaBufInfoEiPNSt3__16vectorINS0_9DmaBufferENS1_9allocatorIS3_EEEEb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10getServiceINS_8hardware14ICameraServiceEEEiRKNS_8String16EPNS_2spIT_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10isSeekableEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android10nativeOpenEP7_JNIEnvP7_jclassix);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android11BnInterfaceINS_20IRemoteDisplayClientEE10onAsBinderEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android11BnInterfaceINS_23IRegionSamplingListenerEE10onAsBinderEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android11JHidlMemory12javaToNativeEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android11JHidlMemory16getNativeContextEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android11JHidlMemory6toJavaEP7_JNIEnvRKNS_8hardware11hidl_memoryE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android11JHidlMemory8fromJavaEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android11JHidlMemoryD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android11nativeCloseEP7_JNIEnvP7_jclassx);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android12MessageQueue22raiseAndClearExceptionEP7_JNIEnvPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android12MessageQueueC2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android12MessageQueueD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android12MessageQueueD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android12MessageQueueD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android12MinikinUtils10forFontRunINS_9PaintGlue14GetTextFunctorEEEvRKN7minikin6LayoutEPNS_5PaintERT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android13JNativeHandle19MakeCppNativeHandleEP7_JNIEnvP8_jobjectPNS_16EphemeralStorageE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android13JNativeHandle23MakeJavaNativeHandleObjEP7_JNIEnvPK13native_handle);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android13JNativeHandle29AllocJavaNativeHandleObjArrayEP7_JNIEnvi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime10getRuntimeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime11onVmCreatedEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime14parseExtraOptsEPcPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime15NewStringLatin1EP7_JNIEnvPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime15javaThreadShellEPv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime16createJavaThreadEPKcPFvPvES3_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime16toSlashClassNameEPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime18parseRuntimeOptionEPKcPcS2_S2_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime19javaCreateThreadEtcEPFiPvES1_PKcijPS1_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime19parseCompilerOptionEPKcPcS2_S2_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime21registerNativeMethodsEP7_JNIEnvPKcPK15JNINativeMethodi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime26parseCompilerRuntimeOptionEPKcPcS2_S2_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime4exitEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime5startEPKcRKNS_6VectorINS_7String8EEEb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime7startVmEPP7_JavaVMPP7_JNIEnvbb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime8callMainERKNS_7String8EP7_jclassRKNS_6VectorIS1_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime8setArgv0EPKcb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime8startRegEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime9addOptionEPKcPv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime9getJNIEnvEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntime9getJavaVMEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntimeC2EPcj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntimeD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14AndroidRuntimeD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14get_env_or_dieEP7_JavaVM);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android14init_FontUtilsEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15JHwRemoteBinder16GetNativeContextEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15JHwRemoteBinder16SetNativeContextEP7_JNIEnvP8_jobjectRKNS_2spIS0_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15JHwRemoteBinder9InitClassEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15JHwRemoteBinder9NewObjectEP7_JNIEnvRKNS_2spINS_8hardware7IBinderEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15JHwRemoteBinder9setBinderERKNS_2spINS_8hardware7IBinderEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15JHwRemoteBinderC2EP7_JNIEnvP8_jobjectRKNS_2spINS_8hardware7IBinderEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15JHwRemoteBinderD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15JHwRemoteBinderD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15MediaMetricsJNI20writeMetricsToBundleEP7_JNIEnvPNS_12mediametrics4ItemEP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15MediaMetricsJNI29nativeToJavaPersistableBundleEP7_JNIEnvPNS_2os17PersistableBundleE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android15getBPNativeDataEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16DeleteScreenshotEPvS0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage16allocStringArrayEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage20allocTemporaryStringEP7_JNIEnvP8_jstring);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage21allocTemporaryStorageEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage24allocTemporaryInt8VectorEP7_JNIEnvP11_jbyteArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage25allocTemporaryFloatVectorEP7_JNIEnvP12_jfloatArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage25allocTemporaryInt16VectorEP7_JNIEnvP12_jshortArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage25allocTemporaryInt32VectorEP7_JNIEnvP10_jintArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage25allocTemporaryInt64VectorEP7_JNIEnvP11_jlongArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage26allocTemporaryDoubleVectorEP7_JNIEnvP13_jdoubleArray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage26allocTemporaryNativeHandleEii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorage7releaseEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorageC2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16EphemeralStorageD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android16nullObjectReturnEPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android17AutoBufferPointerC2EP7_JNIEnvP8_jobjecth);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android17AutoBufferPointerD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android17CopyAssetToStreamEPNS_5AssetE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android17JNIDeviceCallback19onAudioDeviceUpdateEii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android17JNIDeviceCallbackC2EP7_JNIEnvP8_jobjectS4_P10_jmethodID);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android17JNIDeviceCallbackD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android17JNIDeviceCallbackD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18AssetStreamAdaptor4moveEl);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18AssetStreamAdaptor4readEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18AssetStreamAdaptor4seekEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18AssetStreamAdaptor6rewindEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18AssetStreamAdaptorC2EPNS_5AssetE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeInputChannel18setDisposeCallbackEPFvP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEEPvESA_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeInputChannel30invokeAndRemoveDisposeCallbackEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeInputChannelC2ERKNS_2spINS_12InputChannelEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeInputChannelD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueue11handleEventEiiPv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueue14raiseExceptionEP7_JNIEnvPKcP11_jthrowable);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueue23setFileDescriptorEventsEii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueue4wakeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueue8pollOnceEP7_JNIEnvP8_jobjecti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueueC1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueueC2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueueD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueueD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18NativeMessageQueueD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18forwardPdfiumErrorEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android18nativeGetPageCountEP7_JNIEnvP7_jclassx);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android19parcelForJavaObjectEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20VelocityTrackerState11addMovementEPKNS_11MotionEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20VelocityTrackerState11getVelocityEiPfS1_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20VelocityTrackerState12getEstimatorEiPNS_15VelocityTracker9EstimatorE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20VelocityTrackerState22computeCurrentVelocityEif);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20VelocityTrackerState5clearEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20VelocityTrackerStateC2EPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20ibinderForJavaObjectEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20javaObjectForIBinderEP7_JNIEnvRKNS_2spINS_7IBinderEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android20poly_clip_to_frustumEPNS_4PolyE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSender10initializeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSender11handleEventEiiPv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSender12sendKeyEventEjPKNS_8KeyEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSender15sendMotionEventEjPKNS_11MotionEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSender22receiveFinishedSignalsEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSender7disposeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSenderC1EP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEERKNS5_INS_12MessageQueueEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSenderC2EP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEERKNS5_INS_12MessageQueueEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSenderD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSenderD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22NativeInputEventSenderD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22createJavaParcelObjectEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22nativeScaleForPrintingEP7_JNIEnvP7_jclassx);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22poly_clip_to_halfspaceEPNS_4PolyES1_iff);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android22validateCanUseHwBinderERKNS_2spINS_8hardware7IBinderEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23JNIAudioAttributeHelper10makeUniqueEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23JNIAudioAttributeHelper12getJavaArrayEP7_JNIEnvPP13_jobjectArrayi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23JNIAudioAttributeHelper12nativeToJavaEP7_JNIEnvPP8_jobjectRK18audio_attributes_t);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23JNIAudioAttributeHelper14nativeFromJavaEP7_JNIEnvP8_jobjectP18audio_attributes_t);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23NativeInputWindowHandle10updateInfoEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23NativeInputWindowHandle31getInputWindowHandleObjLocalRefEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23NativeInputWindowHandleC2EP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23NativeInputWindowHandleD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23NativeInputWindowHandleD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23newParcelFileDescriptorEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23recycleJavaParcelObjectEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23signalExceptionForErrorEP7_JNIEnvP8_jobjectibi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23signalExceptionForErrorEP7_JNIEnvib);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23throw_sqlite3_exceptionEP7_JNIEnvP7sqlite3);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23throw_sqlite3_exceptionEP7_JNIEnvP7sqlite3PKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23throw_sqlite3_exceptionEP7_JNIEnvPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android23throw_sqlite3_exceptionEP7_JNIEnviPKcS3_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24HardwareRendererObserver13getNextBufferEP7_JNIEnvP11_jlongArrayPi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24HardwareRendererObserver6notifyEPKx);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24HardwareRendererObserverC2EP7_JavaVMP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24HardwareRendererObserverD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24HardwareRendererObserverD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24JNISurfaceTextureContext16onFrameAvailableERKNS_10BufferItemE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24JNISurfaceTextureContext9detachJNIEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24JNISurfaceTextureContext9getJNIEnvEPb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24JNISurfaceTextureContextC1EP7_JNIEnvP8_jobjectP7_jclass);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24JNISurfaceTextureContextC2EP7_JNIEnvP8_jobjectP7_jclass);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24JNISurfaceTextureContextD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24JNISurfaceTextureContextD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24JNISurfaceTextureContextD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiver10initializeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiver11handleEventEiiPv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiver11setFdEventsEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiver13consumeEventsEP7_JNIEnvbxPb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiver16finishInputEventEjb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiver7disposeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiverC1EP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEERKNS5_INS_12MessageQueueEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiverC2EP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEERKNS5_INS_12MessageQueueEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiverD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiverD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android24NativeInputEventReceiverD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android25AssetManagerForJavaObjectEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android25register_android_os_DebugEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android25register_android_os_TraceEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android25register_android_util_LogEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26HwBinderDeathRecipientList3addERKNS_2spINS_22HwBinderDeathRecipientEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26HwBinderDeathRecipientList4findEP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26HwBinderDeathRecipientList4lockEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26HwBinderDeathRecipientList6removeERKNS_2spINS_22HwBinderDeathRecipientEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26HwBinderDeathRecipientListC2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26HwBinderDeathRecipientListD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26HwBinderDeathRecipientListD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiver13dispatchVsyncExyj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiver15dispatchHotplugExyb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiver21dispatchConfigChangedExyix);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiver7disposeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiverC1EP7_JNIEnvP8_jobjectRKNS_2spINS_12MessageQueueEEEii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiverC2EP7_JNIEnvP8_jobjectRKNS_2spINS_12MessageQueueEEEii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiverD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiverD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26NativeDisplayEventReceiverD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26SurfaceTexture_getProducerEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26audioEffectDescriptorClassEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26register_android_os_HwBlobEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android26register_android_os_ParcelEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android27JNIAudioVolumeGroupCallback13onServiceDiedEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android27JNIAudioVolumeGroupCallback25onAudioVolumeGroupChangedENS_14volume_group_tEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android27JNIAudioVolumeGroupCallbackC2EP7_JNIEnvP8_jobjectS4_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android27JNIAudioVolumeGroupCallbackD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android27JNIAudioVolumeGroupCallbackD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android27register_android_os_SELinuxEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28NativeInputApplicationHandle10updateInfoEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28NativeInputApplicationHandle36getInputApplicationHandleObjLocalRefEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28NativeInputApplicationHandleC2EP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28NativeInputApplicationHandleD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28NativeInputApplicationHandleD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28NdkAssetManagerForJavaObjectEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28register_android_os_HwBinderEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28register_android_os_HwParcelEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android28set_dalvik_blockguard_policyEP7_JNIEnvi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android29android_NativeActivity_finishEP15ANativeActivity);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android29android_view_KeyEvent_recycleEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android29android_view_PointerIcon_loadEP7_JNIEnvP8_jobjectS3_PNS_11PointerIconE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android29register_android_app_ActivityEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android29register_android_view_SurfaceEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android2spINS_10AudioTrackEEaSEPS1_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android2spINS_11AudioRecordEEaSEPS1_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android30AssetManagerForNdkAssetManagerEP13AAssetManager);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android30android_view_KeyEvent_toNativeEP7_JNIEnvP8_jobjectPNS_8KeyEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android30register_android_graphics_PathEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android30register_android_os_HidlMemoryEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android30register_android_os_MemoryFileEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android30register_android_util_EventLogEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android30register_android_util_StatsLogEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android30register_android_view_KeyEventEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31android_view_InputDevice_createEP7_JNIEnvRKNS_15InputDeviceInfoE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31android_view_Surface_getSurfaceEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31convertMicrophoneInfoFromNativeEP7_JNIEnvPP8_jobjectPKNS_5media14MicrophoneInfoE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31register_android_graphics_PaintEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31register_android_opengl_classesEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31register_android_os_HidlSupportEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31register_android_os_SystemClockEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31register_android_os_VintfObjectEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android31throw_sqlite3_exception_errcodeEP7_JNIEnviPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32CameraMetadata_getNativeMetadataEP7_JNIEnvP8_jobjectPNS_14CameraMetadataE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32SurfaceTexture_getSurfaceTextureEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32android_view_KeyEvent_fromNativeEP7_JNIEnvPKNS_8KeyEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32android_view_MotionEvent_recycleEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_graphics_CanvasEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_graphics_MatrixEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_graphics_RegionEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_os_FileObserverEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_os_MessageQueueEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_os_NativeHandleEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_os_SharedMemoryEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_security_ScryptEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_text_HyphenatorEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_util_PathParserEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_view_InputQueueEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android32register_android_view_RenderNodeEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33android_Configuration_getFromJavaEP7_JNIEnvP8_jobjectP14AConfiguration);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33android_view_Surface_isInstanceOfEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33register_android_content_XmlBlockEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33register_android_graphics_PictureEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33register_android_net_NetworkUtilsEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33register_android_view_InputDeviceEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33register_android_view_MotionEventEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33register_android_view_PointerIconEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android33register_android_view_TextureViewEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android34createAudioDeviceAddressFromNativeEP7_JNIEnvPP8_jobjectPKNS_19AudioDeviceTypeAddrE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android34register_android_os_HwRemoteBinderEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android34register_android_os_UEventObserverEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android34register_android_view_InputChannelEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android34register_android_view_TextureLayerEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android35android_SurfaceTexture_isInstanceOfEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android35android_graphics_Matrix_getSkMatrixEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android35android_view_KeyCharacterMap_createEP7_JNIEnviRKNS_2spINS_15KeyCharacterMapEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android35register_android_app_ActivityThreadEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android35register_android_app_NativeActivityEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android35register_android_media_MediaMetricsEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36android_NativeActivity_hideSoftInputEP15ANativeActivityi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36android_NativeActivity_showSoftInputEP15ANativeActivityi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36android_os_Debug_getDeathObjectCountEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36android_os_Debug_getLocalObjectCountEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36android_os_Debug_getProxyObjectCountEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36android_util_Log_isVerboseLogEnabledEPKc);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36android_view_Surface_getNativeWindowEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_content_StringBlockEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_graphics_ColorSpaceEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_graphics_DrawFilterEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_graphics_FontFamilyEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_graphics_fonts_FontEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_media_RemoteDisplayEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_net_LocalSocketImplEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_os_SystemPropertiesEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_os_VintfRuntimeInfoEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_util_MemoryIntArrayEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_view_SurfaceControlEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android36register_android_view_SurfaceSessionEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37android_NativeActivity_setWindowFlagsEP15ANativeActivityii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37android_view_MotionEvent_getNativePtrEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37android_view_MotionEvent_obtainAsCopyEP7_JNIEnvPKNS_11MotionEventE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37android_view_SurfaceSession_getClientEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37register_android_content_AssetManagerEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37register_android_database_SQLiteDebugEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37register_android_graphics_ColorFilterEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37register_android_graphics_PathMeasureEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37register_android_view_KeyCharacterMapEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android37register_android_view_VelocityTrackerEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38android_NativeActivity_setWindowFormatEP15ANativeActivityi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38android_view_PointerIcon_getLoadedIconEP7_JNIEnvP8_jobjectPNS_11PointerIconE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38android_view_PointerIcon_getSystemIconEP7_JNIEnvP8_jobjecti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38android_view_Surface_createFromSurfaceEP7_JNIEnvRKNS_2spINS_7SurfaceEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38convertAudioEffectDescriptorFromNativeEP7_JNIEnvPP8_jobjectPK19effect_descriptor_s);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_app_admin_SecurityLogEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_app_backup_FullBackupEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_content_res_ApkAssetsEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_database_CursorWindowEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_database_SQLiteGlobalEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_text_AndroidCharacterEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_util_StatsLogInternalEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_view_InputEventSenderEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android38register_android_view_ThreadedRendererEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39android_os_MessageQueue_getMessageQueueEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39android_view_PointerIcon_loadSystemIconEP7_JNIEnvP8_jobjectiPNS_11PointerIconE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39register_android_backup_BackupDataInputEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39register_android_content_res_ObbScannerEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39register_android_graphics_pdf_PdfEditorEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39register_android_os_GraphicsEnvironmentEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39register_android_util_jar_StrictJarFileEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39register_android_view_DisplayListCanvasEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39register_android_view_InputWindowHandleEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android39register_com_android_internal_os_ZygoteEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android40android_view_InputWindowHandle_getHandleEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android40register_android_backup_BackupDataOutputEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android40register_android_ddm_DdmHandleNativeHeapEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android40register_android_graphics_CanvasPropertyEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android40register_android_graphics_SurfaceTextureEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android40register_android_view_InputEventReceiverEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android40register_android_view_RenderNodeAnimatorEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android41android_view_InputChannel_getInputChannelEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android41register_android_graphics_pdf_PdfDocumentEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android41register_android_graphics_pdf_PdfRendererEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android42register_android_content_res_ConfigurationEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android42register_android_database_SQLiteConnectionEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android42register_android_graphics_BLASTBufferQueueEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android42register_android_graphics_fonts_FontFamilyEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android42register_android_graphics_text_LineBreakerEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android42register_android_service_DataLoaderServiceEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android42register_android_view_DisplayEventReceiverEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android43register_android_graphics_text_MeasuredTextEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android43register_com_android_internal_os_ZygoteInitEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android44android_view_InputChannel_setDisposeCallbackEP7_JNIEnvP8_jobjectPFvS1_S3_RKNS_2spINS_12InputChannelEEEPvES9_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android44convertAudioEffectDescriptorVectorFromNativeEP7_JNIEnvPP13_jobjectArrayRKNSt3__16vectorI19effect_descriptor_sNS5_9allocatorIS7_EEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android44register_android_backup_FileBackupHelperBaseEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android44register_android_view_InputApplicationHandleEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android44register_com_android_internal_os_FuseAppLoopEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android44register_com_android_internal_os_RuntimeInitEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android45android_view_InputApplicationHandle_getHandleEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android46register_android_backup_BackupHelperDispatcherEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android47register_android_animation_PropertyValuesHolderEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android49android_hardware_display_DisplayViewport_toNativeEP7_JNIEnvP8_jobjectPNS_15DisplayViewportE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android49register_android_graphics_drawable_VectorDrawableEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android49register_android_hardware_display_DisplayViewportEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android49register_android_view_CompositionSamplingListenerEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android50register_android_graphics_HardwareRendererObserverEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android50register_android_os_incremental_IncrementalManagerEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android51register_com_android_internal_os_ClassLoaderFactoryEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android52android_hardware_HardwareBuffer_convertToPixelFormatEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android52register_com_android_internal_util_VirtualRefBasePtrEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android53android_view_Surface_createFromIGraphicBufferProducerEP7_JNIEnvRKNS_2spINS_22IGraphicBufferProducerEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android53register_android_server_NetworkManagementSocketTaggerEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android54android_graphics_GraphicBuffer_getNativeGraphicsBufferEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android54android_hardware_HardwareBuffer_convertFromPixelFormatEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android55android_hardware_HardwareBuffer_getNativeHardwareBufferEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android56android_graphics_GraphicBuffer_createFromAHardwareBufferEP7_JNIEnvP15AHardwareBuffer);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android57android_hardware_HardwareBuffer_convertToGrallocUsageBitsEy);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android57android_hardware_HardwareBuffer_createFromAHardwareBufferEP7_JNIEnvP15AHardwareBuffer);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android57register_android_graphics_drawable_AnimatedVectorDrawableEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android57register_com_android_internal_content_NativeLibraryHelperEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android5vintf9to_stringINS0_13KernelVersionEEENSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android5vintf9to_stringINS0_7VersionEEENSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android60register_com_android_internal_os_ZygoteInit_nativeZygoteInitEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android6bitmap10toSkBitmapExP8SkBitmap);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android6bitmap12createBitmapEP7_JNIEnvPNS_6BitmapEiP11_jbyteArrayP8_jobjecti);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android6bitmap12reinitBitmapEP7_JNIEnvP8_jobjectRK11SkImageInfob);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android6bitmap8toBitmapEx);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android76register_com_android_internal_view_animation_NativeInterpolatorFactoryHelperEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob16GetNativeContextEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob16SetNativeContextEP7_JNIEnvP8_jobjectRKNS_2spIS0_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob16specializeBlobToENS0_8BlobTypeE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob4dataEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob5setToEPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob5writeEjPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob7putBlobEjRKNS_2spIS0_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob9InitClassEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob9NewObjectEP7_JNIEnvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlob9NewObjectEP7_JNIEnvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlobC2EP7_JNIEnvP8_jobjectj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlobD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7JHwBlobD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7Picture12endRecordingEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7Picture14beginRecordingEii);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7Picture16CreateFromStreamEP8SkStream);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7Picture4drawEPNS_6CanvasE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7PictureC2EO5sk_spI9SkPictureE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android7PictureC2EPKS0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android8getBlockEPvmPhm);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android8hardware10fromBinderINS_4hidl4base4V1_05IBaseENS4_8BpHwBaseENS4_8BnHwBaseEEENS_2spIT_EERKNS8_INS0_7IBinderEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinder10onTransactEjRKNS_8hardware6ParcelEPS2_jNSt3__18functionIFvRS2_EEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinder15GetNativeBinderEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinder16SetNativeContextEP7_JNIEnvP8_jobjectRKNS_2spINS_15JHwBinderHolderEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinder9InitClassEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinderC1EP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinderC2EP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinderD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinderD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwBinderD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel10getStorageEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel16GetNativeContextEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel16SetNativeContextEP7_JNIEnvP8_jobjectRKNS_2spIS0_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel19setTransactCallbackENSt3__18functionIFvRNS_8hardware6ParcelEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel4sendEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel9InitClassEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel9NewObjectEP7_JNIEnv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel9getParcelEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcel9setParcelEPNS_8hardware6ParcelEb);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcelC2EP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcelD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9JHwParcelD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils10TiffWriter8addEntryIdEEitjPKT_j);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils10TiffWriter8addEntryIhEEitjPKT_j);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils10TiffWriter8addEntryIiEEitjPKT_j);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils10TiffWriter8addEntryIjEEitjPKT_j);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils10TiffWriter8addEntryItEEitjPKT_j);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplIdED0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplIdED2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplIhED0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplIhED2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplIiED0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplIiED2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplIjED0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplIjED2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplItED0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN7android9img_utils13TiffEntryImplItED2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN8GIFMovie11onGetBitmapEP8SkBitmap);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN8GIFMovie9onGetInfoEPN5Movie4InfoE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN8GIFMovie9onSetTimeEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN8GIFMovieC2EP8SkStream);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN8GIFMovieD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZN8GIFMovieD2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext10getGpsDataEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext10hasGpsDataEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext12getThumbnailEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext12hasThumbnailEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext14getCaptureTimeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext14getDescriptionEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext14getOrientationEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext14hasCaptureTimeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext14hasDescriptionEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext17getThumbnailWidthEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext18getCharacteristicsEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext18getThumbnailHeightEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK13NativeContext9getResultEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK15NinePatchPeeker10getPaddingEP7_JNIEnvP8_jobject);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK15NinePatchPeeker21createNinePatchInsetsEP7_JNIEnvf);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK16InputStripSource6getIfdEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK16JNICameraContext33isRawImageCallbackBufferAvailableEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK17DirectStripSource6getIfdEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK18FileDescriptorInfo12DetachSocketERKNSt3__18functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK18FileDescriptorInfo14ReopenOrDetachERKNSt3__18functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK18FileDescriptorInfo16RefersToSameFileEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK23FileDescriptorWhitelist9IsAllowedERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android10AxisHelper13getStyleValueEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android10AxisHelper6getTagEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android10ListHelper3getEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android10ListHelper4sizeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_12DisplayStateEE10do_compareEPKvS4_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_12DisplayStateEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_12DisplayStateEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_12DisplayStateEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_12DisplayStateEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_12DisplayStateEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_12DisplayStateEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE10do_compareEPKvS6_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP26audiotrack_callback_cookieE10do_compareEPKvS5_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP26audiotrack_callback_cookieE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP26audiotrack_callback_cookieE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP26audiotrack_callback_cookieE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP26audiotrack_callback_cookieE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP26audiotrack_callback_cookieE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP26audiotrack_callback_cookieE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP27audiorecord_callback_cookieE10do_compareEPKvS5_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP27audiorecord_callback_cookieE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP27audiorecord_callback_cookieE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP27audiorecord_callback_cookieE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP27audiorecord_callback_cookieE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP27audiorecord_callback_cookieE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android12SortedVectorIP27audiorecord_callback_cookieE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android15JHwRemoteBinder21getDeathRecipientListEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android15JHwRemoteBinder9getBinderEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android18AssetStreamAdaptor11getPositionEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android18AssetStreamAdaptor11hasPositionEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android18AssetStreamAdaptor11onDuplicateEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android18AssetStreamAdaptor7isAtEndEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android18AssetStreamAdaptor9getLengthEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorI12JavaVMOptionE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorI12JavaVMOptionE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorI12JavaVMOptionE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorI12JavaVMOptionE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorI12JavaVMOptionE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorI12JavaVMOptionE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_11DisplayInfoEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_11DisplayInfoEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_11DisplayInfoEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_11DisplayInfoEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_11DisplayInfoEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_11DisplayInfoEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_13PointerCoordsEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_13PointerCoordsEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_13PointerCoordsEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_13PointerCoordsEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_13PointerCoordsEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_13PointerCoordsEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16EphemeralStorage4ItemEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16EphemeralStorage4ItemEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16EphemeralStorage4ItemEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16EphemeralStorage4ItemEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16EphemeralStorage4ItemEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16EphemeralStorage4ItemEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_17PointerPropertiesEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_17PointerPropertiesEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_17PointerPropertiesEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_17PointerPropertiesEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_17PointerPropertiesEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_17PointerPropertiesEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_19AudioDeviceTypeAddrEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_19AudioDeviceTypeAddrEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_19AudioDeviceTypeAddrEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_19AudioDeviceTypeAddrEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_19AudioDeviceTypeAddrEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_19AudioDeviceTypeAddrEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_22AudioMixMatchCriterionEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_22AudioMixMatchCriterionEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_22AudioMixMatchCriterionEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_22AudioMixMatchCriterionEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_22AudioMixMatchCriterionEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_22AudioMixMatchCriterionEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_6SensorEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_6SensorEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_6SensorEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_6SensorEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_6SensorEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_6SensorEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7JHwBlob8BlobInfoEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7JHwBlob8BlobInfoEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7JHwBlob8BlobInfoEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7JHwBlob8BlobInfoEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7JHwBlob8BlobInfoEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7JHwBlob8BlobInfoEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7String8EE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7String8EE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7String8EE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7String8EE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7String8EE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_7String8EE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8AudioMixEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8AudioMixEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8AudioMixEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8AudioMixEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8AudioMixEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8AudioMixEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8KeyEventEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8KeyEventEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8KeyEventEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8KeyEventEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8KeyEventEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8KeyEventEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP11_jbyteArrayE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP11_jbyteArrayE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP11_jbyteArrayE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP11_jbyteArrayE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP11_jbyteArrayE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP11_jbyteArrayE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP14ScopedUtfCharsE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP14ScopedUtfCharsE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP14ScopedUtfCharsE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP14ScopedUtfCharsE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP14ScopedUtfCharsE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIP14ScopedUtfCharsE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_10InputEventEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_10InputEventEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_10InputEventEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_10InputEventEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_10InputEventEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_10InputEventEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_6LooperEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_6LooperEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_6LooperEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_6LooperEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_6LooperEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_6LooperEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_9img_utils11StripSourceEE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_9img_utils11StripSourceEE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_9img_utils11StripSourceEE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_9img_utils11StripSourceEE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_9img_utils11StripSourceEE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIPNS_9img_utils11StripSourceEE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIdE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIdE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIdE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIdE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIdE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIdE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIfE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIfE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIfE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIfE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIfE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIfE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIhE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIhE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIhE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIhE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIhE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIhE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIiE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIiE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIiE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIiE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIiE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIiE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIjE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIjE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIjE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIjE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIjE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIjE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorItE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorItE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorItE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorItE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorItE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorItE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIxE10do_destroyEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIxE12do_constructEPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIxE15do_move_forwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIxE16do_move_backwardEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIxE7do_copyEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android6VectorIxE8do_splatEPvPKvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob13writeToParcelEPNS_8hardware6ParcelE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob21writeEmbeddedToParcelEPNS_8hardware6ParcelEjj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob21writeSubBlobsToParcelEPNS_8hardware6ParcelEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob4dataEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob4readEjPvj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob4sizeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob4typeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob9getHandleEPj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7JHwBlob9getStringEjPPKNS_8hardware11hidl_stringE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7Picture15makePartialCopyEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7Picture5widthEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7Picture6heightEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android7Picture9serializeEP9SkWStream);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9JHwParcel7wasSentEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils10TiffWriter10buildEntryIdEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils10TiffWriter10buildEntryIhEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils10TiffWriter10buildEntryIiEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils10TiffWriter10buildEntryIjEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils10TiffWriter10buildEntryItEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE12writeTagInfoEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE13getDataHelperEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE13getEndiannessEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE18getComparableValueEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE6getTagEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE7getSizeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE7getTypeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE8getCountEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIdE9writeDataEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE12writeTagInfoEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE13getDataHelperEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE13getEndiannessEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE18getComparableValueEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE6getTagEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE7getSizeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE7getTypeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE8getCountEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIhE9writeDataEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE12writeTagInfoEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE13getDataHelperEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE13getEndiannessEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE18getComparableValueEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE6getTagEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE7getSizeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE7getTypeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE8getCountEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIiE9writeDataEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE12writeTagInfoEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE13getDataHelperEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE13getEndiannessEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE18getComparableValueEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE6getTagEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE7getSizeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE7getTypeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE8getCountEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplIjE9writeDataEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE12writeTagInfoEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE13getDataHelperEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE13getEndiannessEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE18getComparableValueEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE6getTagEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE7getSizeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE7getTypeEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE8getCountEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNK7android9img_utils13TiffEntryImplItE9writeDataEjPNS0_12EndianOutputE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7__cloneEPNS0_6__baseIST_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7__cloneEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7__cloneEPNS0_6__baseIST_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7__cloneEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EE7__cloneEPNS0_6__baseISR_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EE7__cloneEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__112__hash_tableINS_17__hash_value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_22__unordered_map_hasherIS7_S8_NS_4hashIS7_EELb1EEENS_21__unordered_map_equalIS7_S8_NS_8equal_toIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__hash_const_iteratorIPNS_11__hash_nodeIS8_PvEEEERKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNKSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE18destroy_deallocateEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7destroyEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EEclEOSE_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE18destroy_deallocateEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7destroyEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EEclEOSE_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EE18destroy_deallocateEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EE7destroyEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EEclEOSE_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableIN7android2spINS1_7IBinderEEENS1_16ISurfaceComposer6SpHashIS3_EENS_8equal_toIS4_EENS_9allocatorIS4_EEE25__emplace_unique_key_argsIS4_JS4_EEENS_4pairINS_15__hash_iteratorIPNS_11__hash_nodeIS4_PvEEEEbEERKT_DpOT0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableIN7android2spINS1_7IBinderEEENS1_16ISurfaceComposer6SpHashIS3_EENS_8equal_toIS4_EENS_9allocatorIS4_EEE6rehashEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableIN7android2spINS1_7IBinderEEENS1_16ISurfaceComposer6SpHashIS3_EENS_8equal_toIS4_EENS_9allocatorIS4_EEE8__rehashEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIN7minikin12MinikinPaintEjEENS_22__unordered_map_hasherIS3_S4_NS2_12LayoutPieces11PaintHasherELb1EEENS_21__unordered_map_equalIS3_S4_NS_8equal_toIS3_EELb1EEENS_9allocatorIS4_EEED2Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE25__emplace_unique_key_argsIiJRKNS_21piecewise_construct_tENS_5tupleIJRKiEEENSK_IJEEEEEENS_4pairINS_15__hash_iteratorIPNS_11__hash_nodeIS4_PvEEEEbEERKT_DpOT0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE25__emplace_unique_key_argsIiJRKNS_4pairIKiS3_EEEEENSH_INS_15__hash_iteratorIPNS_11__hash_nodeIS4_PvEEEEbEERKT_DpOT0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE6rehashEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE6removeENS_21__hash_const_iteratorIPNS_11__hash_nodeIS4_PvEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE8__rehashEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiiEENS_22__unordered_map_hasherIiS2_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS2_NS_8equal_toIiEELb1EEENS_9allocatorIS2_EEE25__emplace_unique_key_argsIiJNS_4pairIiiEEEEENSF_INS_15__hash_iteratorIPNS_11__hash_nodeIS2_PvEEEEbEERKT_DpOT0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiiEENS_22__unordered_map_hasherIiS2_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS2_NS_8equal_toIiEELb1EEENS_9allocatorIS2_EEE25__emplace_unique_key_argsIiJRKNS_4pairIKiiEEEEENSF_INS_15__hash_iteratorIPNS_11__hash_nodeIS2_PvEEEEbEERKT_DpOT0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiiEENS_22__unordered_map_hasherIiS2_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS2_NS_8equal_toIiEELb1EEENS_9allocatorIS2_EEE6rehashEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIiiEENS_22__unordered_map_hasherIiS2_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS2_NS_8equal_toIiEELb1EEENS_9allocatorIS2_EEE8__rehashEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIjjEENS_22__unordered_map_hasherIjS2_NS_4hashIjEELb1EEENS_21__unordered_map_equalIjS2_NS_8equal_toIjEELb1EEENS_9allocatorIS2_EEE25__emplace_unique_key_argsIjJRjSF_EEENS_4pairINS_15__hash_iteratorIPNS_11__hash_nodeIS2_PvEEEEbEERKT_DpOT0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIjjEENS_22__unordered_map_hasherIjS2_NS_4hashIjEELb1EEENS_21__unordered_map_equalIjS2_NS_8equal_toIjEELb1EEENS_9allocatorIS2_EEE6rehashEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIjjEENS_22__unordered_map_hasherIjS2_NS_4hashIjEELb1EEENS_21__unordered_map_equalIjS2_NS_8equal_toIjEELb1EEENS_9allocatorIS2_EEE6removeENS_21__hash_const_iteratorIPNS_11__hash_nodeIS2_PvEEEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__112__hash_tableINS_17__hash_value_typeIjjEENS_22__unordered_map_hasherIjS2_NS_4hashIjEELb1EEENS_21__unordered_map_equalIjS2_NS_8equal_toIjEELb1EEENS_9allocatorIS2_EEE8__rehashEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__113__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__114__split_bufferINS_17basic_string_viewIcNS_11char_traitsIcEEEERNS_9allocatorIS4_EEE9push_backEOS4_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekoffExNS_8ios_base7seekdirEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE8overflowEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9pbackfailEi);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9underflowEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__120__shared_ptr_emplaceIN7android14CameraMetadataENS_9allocatorIS2_EEE16__on_zero_sharedEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__120__shared_ptr_emplaceIN7android14CameraMetadataENS_9allocatorIS2_EEE21__on_zero_shared_weakEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__120__shared_ptr_emplaceIN7android15MinikinFontSkiaENS_9allocatorIS2_EEE16__on_zero_sharedEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__120__shared_ptr_emplaceIN7android15MinikinFontSkiaENS_9allocatorIS2_EEE21__on_zero_shared_weakEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__120__shared_ptr_emplaceIN7android16JGlobalRefHolderENS_9allocatorIS2_EEE16__on_zero_sharedEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__120__shared_ptr_emplaceIN7android16JGlobalRefHolderENS_9allocatorIS2_EEE21__on_zero_shared_weakEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__120__shared_ptr_emplaceIN7minikin10FontFamilyENS_9allocatorIS2_EEE16__on_zero_sharedEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__120__shared_ptr_emplaceIN7minikin10FontFamilyENS_9allocatorIS2_EEE21__on_zero_shared_weakEv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__127__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeIN7android15ResTable_configENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_10shared_ptrIN7minikin14FontCollectionEEEEENS_19__map_value_compareIS7_SC_NS_4lessIS7_EELb1EEENS5_ISC_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEERPNS_15__tree_end_nodeISN_EERKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEERPNS_15__tree_end_nodeISJ_EESK_RKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEERPNS_15__tree_end_nodeISJ_EERKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE30__emplace_hint_unique_key_argsIS7_JRKNS_4pairIKS7_S7_EEEEENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEENS_21__tree_const_iteratorIS8_SP_iEERKT_DpOT0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeINS_17basic_string_viewIcNS_11char_traitsIcEEEEyEENS_19__map_value_compareIS5_S6_NS_4lessIS5_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIf7SkPointEENS_19__map_value_compareIfS3_NS_4lessIfEELb1EEENS_9allocatorIS3_EEE12__find_equalIfEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEERPNS_15__tree_end_nodeISF_EESG_RKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIf7SkPointEENS_19__map_value_compareIfS3_NS_4lessIfEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIffEENS_19__map_value_compareIfS2_NS_4lessIfEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIiNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEENS_19__map_value_compareIiS8_NS_4lessIiEELb1EEENS5_IS8_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEERPNS_15__tree_end_nodeISJ_EESK_RKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIiNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEENS_19__map_value_compareIiS8_NS_4lessIiEELb1EEENS5_IS8_EEE30__emplace_hint_unique_key_argsIiJRKNS_4pairIKiS7_EEEEENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEENS_21__tree_const_iteratorIS8_SP_iEERKT_DpOT0_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIiNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEENS_19__map_value_compareIiS8_NS_4lessIiEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIiNS_6vectorIN7android15AudioAttributesENS_9allocatorIS4_EEEEEENS_19__map_value_compareIiS8_NS_4lessIiEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIiPKcEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIifEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIixEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIyNS_10unique_ptrI14ScopedLocalRefIP11_jbyteArrayENS_14default_deleteIS6_EEEEEENS_19__map_value_compareIySA_NS_4lessIyEELb1EEENS_9allocatorISA_EEE5eraseENS_21__tree_const_iteratorISA_PNS_11__tree_nodeISA_PvEEiEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12__value_typeIyNS_10unique_ptrI14ScopedLocalRefIP11_jbyteArrayENS_14default_deleteIS6_EEEEEENS_19__map_value_compareIySA_NS_4lessIyEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS6_PNS_11__tree_nodeIS6_SD_EEiEERPNS_15__tree_end_nodeISF_EESG_RKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEERPNS_15__tree_end_nodeISF_EERKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeIiNS_4lessIiEENS_9allocatorIiEEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS8_EEiEERPNS_15__tree_end_nodeISA_EESB_RKT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorI11sock_filterNS_9allocatorIS1_EEE21__push_back_slow_pathIRKS1_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorI11sock_filterNS_9allocatorIS1_EEE21__push_back_slow_pathIS1_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorI18audio_attributes_tNS_9allocatorIS1_EEEC2ERKS4_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorI19audio_stream_type_tNS_9allocatorIS1_EEEC2ERKS4_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorI7SkPointNS_9allocatorIS1_EEE21__push_back_slow_pathIRKS1_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorI7SkPointNS_9allocatorIS1_EEE21__push_back_slow_pathIS1_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN15SkFontArguments4AxisEN7android10uirenderer18InlineStdAllocatorIS2_Lj2EEEE24__emplace_back_slow_pathIJS2_EEEvDpOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN15SkFontArguments4AxisEN7android10uirenderer18InlineStdAllocatorIS2_Lj2EEEE7reserveEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7android10dmabufinfo9DmaBufferENS_9allocatorIS3_EEE24__emplace_back_slow_pathIJRmyiRA10_KcSB_EEEvDpOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7android10dmabufinfo9DmaBufferENS_9allocatorIS3_EEE24__emplace_back_slow_pathIJRyyS8_RNS_12basic_stringIcNS_11char_traitsIcEENS4_IcEEEESE_EEEvDpOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7android10dmabufinfo9DmaBufferENS_9allocatorIS3_EEE24__emplace_back_slow_pathIJmRyS8_RPcPKcEEEvDpOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7android15AudioAttributesENS_9allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7android2spINS1_22HwBinderDeathRecipientEEENS_9allocatorIS4_EEE21__push_back_slow_pathIRKS4_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7android8graphics6BitmapENS_9allocatorIS3_EEE8__appendEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7minikin13FontVariationENS_9allocatorIS2_EEE21__push_back_slow_pathIS2_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7minikin13FontVariationENS_9allocatorIS2_EEE24__emplace_back_slow_pathIJjRfEEEvDpOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7minikin4FontENS_9allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIN7minikin4FontENS_9allocatorIS2_EEE21__push_back_slow_pathIS2_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorINS_10shared_ptrIN7minikin10FontFamilyEEENS_9allocatorIS4_EEE24__emplace_back_slow_pathIJRS4_EEEvDpOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorINS_10shared_ptrIN7minikin10FontFamilyEEENS_9allocatorIS4_EEE7reserveEj);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorINS_10unique_ptrI14ScopedUtfCharsNS_14default_deleteIS2_EEEENS_9allocatorIS5_EEE21__push_back_slow_pathIS5_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorINS_10unique_ptrIN7minikin3RunENS_14default_deleteIS3_EEEENS_9allocatorIS6_EEE24__emplace_back_slow_pathIJNS1_INS2_14ReplacementRunENS4_ISB_EEEEEEEvDpOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorINS_10unique_ptrIN7minikin3RunENS_14default_deleteIS3_EEEENS_9allocatorIS6_EEE24__emplace_back_slow_pathIJNS1_INS2_8StyleRunENS4_ISB_EEEEEEEvDpOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIRKS6_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIS6_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorINS_17basic_string_viewIcNS_11char_traitsIcEEEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EEOS4_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIP13native_handleNS_9allocatorIS2_EEEC2ERKS5_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIP14ScopedUtfCharsNS_9allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIPKN7android9ApkAssetsENS_9allocatorIS4_EEE21__push_back_slow_pathIS4_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIPKN7android9ApkAssetsENS_9allocatorIS4_EEEC2ERKS7_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIPKcNS_9allocatorIS2_EEE21__push_back_slow_pathIS2_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIPN7android10PageRecordENS_9allocatorIS3_EEE21__push_back_slow_pathIRKS3_EEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIcNS_9allocatorIcEEE6assignIPcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIcNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIRKfEEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIfEEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIfNS_9allocatorIfEEE6assignIPfEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIfNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIfNS_9allocatorIfEEE6insertIPfEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIfNS_15iterator_traitsIS7_E9referenceEEE5valueENS_11__wrap_iterIS5_EEE4typeENSB_IPKfEES7_S7_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIfNS_9allocatorIfEEEC2ERKS3_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIRKiEEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIiEEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIiNS_9allocatorIiEEE6insertINS_11__wrap_iterIPiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS9_E9referenceEEE5valueES7_E4typeENS5_IPKiEES9_S9_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIiNS_9allocatorIiEEE6insertIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS7_E9referenceEEE5valueENS_11__wrap_iterIS5_EEE4typeENSB_IPKiEES7_S7_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIjEEvOT_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIjNS_9allocatorIjEEE6assignIPjEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__16vectorIjNS_9allocatorIjEEEC2ERKS3_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__17getlineIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_13basic_istreamIT_T0_EES9_RNS_12basic_stringIS6_S7_T1_EES6_);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZNSt3__1lsIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_13basic_ostreamIT_T0_EES9_RKNS_12basic_stringIS6_S7_T1_EE);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZThn8_N7android18NativeMessageQueue11handleEventEiiPv);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZThn8_N7android18NativeMessageQueueD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZThn8_N7android18NativeMessageQueueD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android10InputQueueD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android10InputQueueD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android12MessageQueueD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android12MessageQueueD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android18NativeMessageQueueD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android18NativeMessageQueueD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android22NativeInputEventSenderD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android22NativeInputEventSenderD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android24JNISurfaceTextureContextD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android24JNISurfaceTextureContextD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android24NativeInputEventReceiverD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android24NativeInputEventReceiverD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android26NativeDisplayEventReceiverD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android26NativeDisplayEventReceiverD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android9JHwBinderD0Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(_ZTv0_n12_N7android9JHwBinderD1Ev);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_fatal_no_abort);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_fatal_va_list);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_format_buffer);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_format_buffer_va_list);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_format_fd);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_format_fd_va_list);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_format_log);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_format_log_va_list);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(async_safe_write_log);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(crypto_scrypt);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(init_android_graphics);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(note_log_drop);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(reallocarray);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(registerFrameworkNatives);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(register_android_graphics_classes);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(statd_writer_trylock);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(stats_log_close);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(statsd_writer_init_lock);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(statsd_writer_init_unlock);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(write_buffer_to_statsd);
DEFINE_INTERCEPTABLE_STUB_FUNCTION(zygote_preload_graphics);

static void __attribute__((constructor(0))) init_stub_library() {
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmapConfig_getConfigFromFormat);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmapConfig_getFormatFromConfig);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_acquireBitmapFromJava);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_acquireRef);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_compress);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_copy);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_getDataSpace);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_getInfo);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_getInfoFromJava);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_getPixels);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_notifyPixelsChanged);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ABitmap_releaseRef);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_clipOutRect);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_clipRect);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_createCanvas);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_destroyCanvas);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_drawBitmap);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_drawRect);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_getNativeHandleFromJava);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_isSupportedPixelFormat);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ACanvas_setBuffer);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", AMatrix_getContents);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", APaint_createPaint);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", APaint_destroyPaint);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", APaint_setBlendMode);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ARegionIterator_acquireIterator);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ARegionIterator_getRect);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ARegionIterator_getTotalBounds);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ARegionIterator_isComplex);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ARegionIterator_isDone);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ARegionIterator_next);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ARegionIterator_releaseIterator);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", ARenderThread_dumpGraphicsMemory);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifCloseFile);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifExtensionToGCB);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetCode);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetCodeNext);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetExtension);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetExtensionNext);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetImageDesc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetLZCodes);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetLine);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetPixel);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetRecordType);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifGetScreenDesc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifOpen);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifOpenFileHandle);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifOpenFileName);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifSavedExtensionToGCB);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", DGifSlurp);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", FreeLastSavedImage);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifAddExtensionBlock);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifApplyTranslation);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifBitSize);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifFreeExtensions);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifFreeMapObject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifFreeSavedImages);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifMakeMapObject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifMakeSavedImage);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", GifUnionColorMap);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z10doThrowIAEP7_JNIEnvPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z10doThrowIOEP7_JNIEnvPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z10doThrowISEP7_JNIEnvPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z10doThrowNPEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z10error_exitP18jpeg_common_struct);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z10getContextx);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z11doThrowOOMEP7_JNIEnvPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z11getMimeType20SkEncodedImageFormat);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z12checkGlErrorP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z13create_jmovieP7_JNIEnvP5Movie);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z13doThrowAIOOBEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z17get_native_cameraP7_JNIEnvP8_jobjectPP16JNICameraContext);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z19CopyJavaInputStreamP7_JNIEnvP8_jobjectP11_jbyteArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z19_set_seccomp_filter10FilterType);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z21postProcessAndReleaseP7_JNIEnvP8_jobjectNSt3__110unique_ptrIN7android6CanvasENS3_14default_deleteIS6_EEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z22get_device_from_objectP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z22set_app_seccomp_filterv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z23getMimeTypeAsJavaStringP7_JNIEnv20SkEncodedImageFormat);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z23get_request_from_objectP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z25_install_setuidgid_filterjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z25android_os_Process_setGidP7_JNIEnvP8_jobjecti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z25android_os_Process_setUidP7_JNIEnvP8_jobjecti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z25set_system_seccomp_filterv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z26android_os_Process_getPidsP7_JNIEnvP8_jobjectP8_jstringP10_jintArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z26get_exclusive_cpuset_cores11SchedPolicyP9cpu_set_t);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z26register_android_os_BinderP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z27android_os_Process_setArgV0P7_JNIEnvP8_jobjectP8_jstring);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z27register_android_media_midiP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z27register_android_os_ProcessP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z28CreateByteArrayStreamAdaptorP7_JNIEnvP11_jbyteArrayjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z28CreateJavaInputStreamAdaptorP7_JNIEnvP8_jobjectP11_jbyteArrayb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z29CreateByteBufferStreamAdaptorP7_JNIEnvP8_jobjectjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z29CreateJavaOutputStreamAdaptorP7_JNIEnvP8_jobjectP11_jbyteArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z29android_os_Process_sendSignalP7_JNIEnvP8_jobjectii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z29set_app_zygote_seccomp_filterv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z31android_os_Process_readProcFileP7_JNIEnvP8_jobjectP8_jstringP10_jintArrayP13_jobjectArrayP11_jlongArrayP12_jfloatArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z31register_android_graphics_MovieP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32android_os_Process_getGidForNameP7_JNIEnvP8_jobjectP8_jstring);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32android_os_Process_getUidForNameP7_JNIEnvP8_jobjectP8_jstring);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32android_os_Process_parseProcLineP7_JNIEnvP8_jobjectP11_jbyteArrayiiP10_jintArrayP13_jobjectArrayP11_jlongArrayP12_jfloatArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32android_os_Process_readProcLinesP7_JNIEnvP8_jobjectP8_jstringP13_jobjectArrayP11_jlongArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32android_os_Process_setSwappinessP7_JNIEnvP8_jobjectih);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32install_setuidgid_seccomp_filterjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32register_android_graphics_BitmapP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32register_android_graphics_CameraP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32register_android_graphics_ShaderP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z32register_android_hardware_CameraP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z33android_os_Process_setThreadGroupP7_JNIEnvP8_jobjectii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z33register_android_media_AudioTrackP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z33register_android_opengl_jni_EGL14P7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z33register_android_opengl_jni_EGL15P7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34JHwBinder_native_joinRpcThreadpoolv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34android_os_Process_getProcessGroupP7_JNIEnvP8_jobjecti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34android_os_Process_sendSignalQuietP7_JNIEnvP8_jobjectii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34android_os_Process_setProcessGroupP7_JNIEnvP8_jobjectii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_graphics_GraphicsP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_graphics_TypefaceP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_graphics_YuvImageP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_media_AudioRecordP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_media_AudioSystemP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_opengl_jni_EGLExtP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_opengl_jni_GLES10P7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_opengl_jni_GLES11P7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_opengl_jni_GLES20P7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_opengl_jni_GLES30P7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_opengl_jni_GLES31P7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z34register_android_opengl_jni_GLES32P7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z35android_os_Process_killProcessGroupP7_JNIEnvP8_jobjectii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z35register_android_graphics_NinePatchP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z35register_android_hardware_UsbDeviceP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36android_os_Binder_getNativeFinalizerP7_JNIEnvP7_jclass);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36android_os_Process_getExclusiveCoresP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36android_os_Process_getThreadPriorityP7_JNIEnvP8_jobjecti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36android_os_Process_setThreadPriorityP7_JNIEnvP8_jobjectii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36register_android_graphics_MaskFilterP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36register_android_graphics_PathEffectP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36register_android_hardware_SerialPortP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36register_android_hardware_UsbRequestP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z36register_android_media_ToneGeneratorP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37android_media_getIntConstantFromClassP7_JNIEnvP7_jclassPKcS4_Pi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37android_os_Process_getPidsForCommandsP7_JNIEnvP8_jobjectP13_jobjectArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37android_os_Process_getThreadSchedulerP7_JNIEnvP7_jclassi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37android_os_Process_parseProcLineArrayP7_JNIEnvP8_jobjectPciiP10_jintArrayP13_jobjectArrayP11_jlongArrayP12_jfloatArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37android_os_Process_setThreadSchedulerP7_JNIEnvP7_jclassiii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37register_android_media_MicrophoneInfoP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37register_android_opengl_jni_GLES10ExtP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37register_android_opengl_jni_GLES11ExtP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z37register_android_opengl_jni_GLES31ExtP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z38android_media_AudioTrack_getAudioTrackP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z38register_android_graphics_ImageDecoderP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z38register_android_graphics_InterpolatorP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z38register_android_media_AudioAttributesP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z39JHwBinder_native_configureRpcThreadpoolP7_JNIEnvP7_jclassxh);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z39android_os_Process_setApplicationObjectP7_JNIEnvP8_jobjectS2_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z39register_android_graphics_BitmapFactoryP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z39register_android_graphics_GraphicBufferP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z39register_android_hardware_SensorManagerP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z40register_android_hardware_HardwareBufferP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z40register_android_media_AudioVolumeGroupsP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z41android_os_BinderProxy_getNativeFinalizerP7_JNIEnvP7_jclass);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z41android_os_Process_removeAllProcessGroupsP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z41register_android_media_AudioDeviceAddressP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z42android_os_Process_setThreadGroupAndCpusetP7_JNIEnvP8_jobjectii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z43android_os_Process_setCallingThreadPriorityP7_JNIEnvP8_jobjecti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z43register_com_google_android_gles_jni_GLImplP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z44register_android_hardware_camera2_DngCreatorP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z44register_android_media_AudioEffectDescriptorP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z44register_com_google_android_gles_jni_EGLImplP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z45register_android_graphics_BitmapRegionDecoderP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z45register_android_hardware_UsbDeviceConnectionP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z45register_android_media_AudioProductStrategiesP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z48register_android_hardware_camera2_CameraMetadataP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z49register_android_graphics_ByteBufferStreamAdaptorP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z52register_android_media_AudioVolumeGroupChangeHandlerP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z55register_android_graphics_CreateJavaOutputStreamAdaptorP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z56register_android_graphics_drawable_AnimatedImageDrawableP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z56register_android_hardware_camera2_legacy_PerfMeasurementP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z59register_android_hardware_camera2_legacy_LegacyCameraDeviceP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z62register_android_hardware_location_ActivityRecognitionHardwareP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _Z9doThrowREP7_JNIEnvPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI12createRegionEP7_JNIEnvP8SkRegion);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI12hasExceptionEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI13getBitmapInfoEP7_JNIEnvP8_jobjectPj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI13getColorSpaceEP7_JNIEnvP12SkColorSpace11SkColorType);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI13jrect_to_rectEP7_JNIEnvP8_jobjectP6SkRect);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI14irect_to_jrectERK7SkIRectP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI14jrect_to_irectEP7_JNIEnvP8_jobjectP7SkIRect);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI14jrectf_to_rectEP7_JNIEnvP8_jobjectP6SkRect);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI14rect_to_jrectfERK6SkRectP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI15getNativeBitmapEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI15getNativeCanvasEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI15getNativeRegionEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI16convertColorLongEx);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI16ipoint_to_jpointERK8SkIPointP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI16isHardwareConfigEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI16jpoint_to_ipointEP7_JNIEnvP8_jobjectP8SkIPoint);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI16jpointf_to_pointEP7_JNIEnvP8_jobjectP7SkPoint);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI16point_to_jpointfERK7SkPointP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI19getConfigFromFormatEP7_JNIEnv19AndroidBitmapFormat);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI19getFormatFromConfigEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI19getNativeColorSpaceEx);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI24getNativeBitmapColorTypeEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI25createBitmapRegionDecoderEP7_JNIEnvP21SkBitmapRegionDecoder);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI26hardwareLegacyBitmapConfigEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI29colorTypeToLegacyBitmapConfigE11SkColorType);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI29legacyBitmapConfigToColorTypeEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI9SetPixelsEP7_JNIEnvP10_jintArrayiiiiiiP8SkBitmap);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI9get_jrectEP7_JNIEnvP8_jobjectPiS4_S4_S4_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN11GraphicsJNI9set_jrectEP7_JNIEnvP8_jobjectiiii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13HeapAllocator13allocPixelRefEP8SkBitmap);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContext10setGpsDataERK7GpsData);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContext12setThumbnailEPKhjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContext14setCaptureTimeERKN7android7String8E);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContext14setDescriptionERKN7android7String8E);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContext14setOrientationEt);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContext9getWriterEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContextC2ERKN7android14CameraMetadataES3_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContextD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN13NativeContextD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN14JniInputStream4openEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN14JniInputStream4readEPhjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN14JniInputStream4skipEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN14JniInputStream5closeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN14JniInputStreamC2EP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN14JniInputStreamD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN14JniInputStreamD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN15JniOutputStream4openEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN15JniOutputStream5closeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN15JniOutputStream5writeEPKhjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN15JniOutputStreamC2EP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN15JniOutputStreamD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN15JniOutputStreamD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN15NinePatchPeeker5scaleEffii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN15NinePatchPeeker9readChunkEPKcPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16AutoJavaIntArrayC2EP7_JNIEnvP10_jintArrayi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16AutoJavaIntArrayD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16InputStripSource13writeToStreamERN7android9img_utils6OutputEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16InputStripSourceC2EP7_JNIEnvRN7android9img_utils5InputEjjjjjyjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16InputStripSourceD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16InputStripSourceD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext11copyAndPostEP7_JNIEnvRKN7android2spINS2_7IMemoryEEEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext12postMetadataEP7_JNIEnviP21camera_frame_metadata);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext15setCallbackModeEP7_JNIEnvbb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext17addCallbackBufferEP7_JNIEnvP11_jbyteArrayi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext17getCallbackBufferEP7_JNIEnvPN7android6VectorIP11_jbyteArrayEEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext17postDataTimestampExiRKN7android2spINS0_7IMemoryEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext22clearCallbackBuffers_lEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext22clearCallbackBuffers_lEP7_JNIEnvPN7android6VectorIP11_jbyteArrayEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext33postRecordingFrameHandleTimestampExP13native_handle);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext38postRecordingFrameHandleTimestampBatchERKNSt3__16vectorIxNS0_9allocatorIxEEEERKNS1_IP13native_handleNS2_IS8_EEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext6notifyEiii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext7releaseEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContext8postDataEiRKN7android2spINS0_7IMemoryEEEP21camera_frame_metadata);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContextC1EP7_JNIEnvP8_jobjectP7_jclassRKN7android2spINS6_6CameraEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16JNICameraContextC2EP7_JNIEnvP8_jobjectP7_jclassRKN7android2spINS6_6CameraEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16YuvToJpegEncoder21setJpegCompressStructEP20jpeg_compress_structiii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16YuvToJpegEncoder6createEiPi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16YuvToJpegEncoder6encodeEP9SkWStreamPviiPii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN16YuvToJpegEncoderC2EPi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN17AutoJavaByteArrayC2EP7_JNIEnvP11_jbyteArrayi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN17AutoJavaByteArrayD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN17DirectStripSource13writeToStreamERN7android9img_utils6OutputEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN17DirectStripSourceC2EP7_JNIEnvPKhjjjjjyjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN17DirectStripSourceD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN17DirectStripSourceD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18AutoJavaFloatArrayC2EP7_JNIEnvP12_jfloatArrayi9JNIAccess);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18AutoJavaFloatArrayD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18AutoJavaShortArrayC2EP7_JNIEnvP12_jshortArrayi9JNIAccess);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18AutoJavaShortArrayD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18DeathRecipientList3addERKN7android2spI18JavaDeathRecipientEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18DeathRecipientList4findEP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18DeathRecipientList4lockEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18DeathRecipientList6removeERKN7android2spI18JavaDeathRecipientEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18DeathRecipientListC2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18DeathRecipientListD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18DeathRecipientListD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18FileDescriptorInfo12CreateFromFdEiRKNSt3__18functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18FileDescriptorInfo13GetSocketNameEiPNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18FileDescriptorInfoC2E4statRKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEiiiil);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18FileDescriptorInfoC2Ei);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18JniInputByteBuffer4openEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18JniInputByteBuffer4readEPhjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18JniInputByteBuffer5closeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18JniInputByteBufferC2EP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18JniInputByteBufferD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN18JniInputByteBufferD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN19FileDescriptorTable14ReopenOrDetachERKNSt3__18functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN19FileDescriptorTable14RestatInternalERNSt3__13setIiNS0_4lessIiEENS0_9allocatorIiEEEERKNS0_8functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS4_IcEEEEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN19FileDescriptorTable6CreateERKNSt3__16vectorIiNS0_9allocatorIiEEEERKNS0_8functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS2_IcEEEEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN19FileDescriptorTable6RestatERKNSt3__16vectorIiNS0_9allocatorIiEEEERKNS0_8functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS2_IcEEEEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN19FileDescriptorTable7ParseFdEP6direnti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN19FileDescriptorTableC2ERKNSt3__113unordered_mapIiP18FileDescriptorInfoNS0_4hashIiEENS0_8equal_toIiEENS0_9allocatorINS0_4pairIKiS3_EEEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20AshmemPixelAllocator13allocPixelRefEP8SkBitmap);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20AshmemPixelAllocatorC2EP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20JNIAudioPortCallback13onServiceDiedEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20JNIAudioPortCallback21onAudioPortListUpdateEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20JNIAudioPortCallback22onAudioPatchListUpdateEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20JNIAudioPortCallback9sendEventEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20JNIAudioPortCallbackC2EP7_JNIEnvP8_jobjectS3_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20JNIAudioPortCallbackD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20JNIAudioPortCallbackD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20Yuv422IToJpegEncoder12deinterleaveEPhS0_S0_S0_iii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20Yuv422IToJpegEncoder21configSamplingFactorsEP20jpeg_compress_struct);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20Yuv422IToJpegEncoder8compressEP20jpeg_compress_structPhPi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN20Yuv422IToJpegEncoderC2EPi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN21Yuv420SpToJpegEncoder12deinterleaveEPhS0_S0_iii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN21Yuv420SpToJpegEncoder21configSamplingFactorsEP20jpeg_compress_struct);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN21Yuv420SpToJpegEncoder8compressEP20jpeg_compress_structPhPi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN21Yuv420SpToJpegEncoderC2EPi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN23FileDescriptorWhitelist3GetEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN23FileDescriptorWhitelistC2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN31RecyclingClippingPixelAllocator13allocPixelRefEP8SkBitmap);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN31RecyclingClippingPixelAllocator15copyIfNecessaryEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN31RecyclingClippingPixelAllocatorC2EPN7android6BitmapEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN31RecyclingClippingPixelAllocatorD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN31RecyclingClippingPixelAllocatorD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie10DecodeFileEPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie10ensureInfoEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie12DecodeMemoryEPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie12DecodeStreamEP18SkStreamRewindable);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie5widthEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie6bitmapEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie6heightEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie7setTimeEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie8durationEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5Movie8isOpaqueEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN5MovieC2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue11createQueueEP8_jobjectRKNS_2spINS_6LooperEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue11finishEventEPNS_10InputEventEb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue12attachLooperEPNS_6LooperEiPFiiiPvES3_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue12detachLooperEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue12enqueueEventEPNS_10InputEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue13handleMessageERKNS_7MessageE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue14createKeyEventEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue16preDispatchEventEPNS_10InputEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue17createMotionEventEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue17recycleInputEventEPNS_10InputEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue18detachLooperLockedEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue8getEventEPPNS_10InputEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueue9hasEventsEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueueC1EP8_jobjectRKNS_2spINS_6LooperEEEii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueueC2EP8_jobjectRKNS_2spINS_6LooperEEEii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueueD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueueD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10InputQueueD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10dmabufinfo14ReadDmaBufInfoEPNSt3__16vectorINS0_9DmaBufferENS1_9allocatorIS3_EEEERKNS1_12basic_stringIcNS1_11char_traitsIcEENS4_IcEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10dmabufinfo14ReadDmaBufInfoEiPNSt3__16vectorINS0_9DmaBufferENS1_9allocatorIS3_EEEEb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10dmabufinfo16AppendDmaBufInfoEiPNSt3__16vectorINS0_9DmaBufferENS1_9allocatorIS3_EEEEb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10getServiceINS_8hardware14ICameraServiceEEEiRKNS_8String16EPNS_2spIT_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10isSeekableEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android10nativeOpenEP7_JNIEnvP7_jclassix);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android11BnInterfaceINS_20IRemoteDisplayClientEE10onAsBinderEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android11BnInterfaceINS_23IRegionSamplingListenerEE10onAsBinderEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android11JHidlMemory12javaToNativeEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android11JHidlMemory16getNativeContextEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android11JHidlMemory6toJavaEP7_JNIEnvRKNS_8hardware11hidl_memoryE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android11JHidlMemory8fromJavaEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android11JHidlMemoryD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android11nativeCloseEP7_JNIEnvP7_jclassx);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android12MessageQueue22raiseAndClearExceptionEP7_JNIEnvPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android12MessageQueueC2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android12MessageQueueD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android12MessageQueueD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android12MessageQueueD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android12MinikinUtils10forFontRunINS_9PaintGlue14GetTextFunctorEEEvRKN7minikin6LayoutEPNS_5PaintERT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android13JNativeHandle19MakeCppNativeHandleEP7_JNIEnvP8_jobjectPNS_16EphemeralStorageE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android13JNativeHandle23MakeJavaNativeHandleObjEP7_JNIEnvPK13native_handle);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android13JNativeHandle29AllocJavaNativeHandleObjArrayEP7_JNIEnvi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime10getRuntimeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime11onVmCreatedEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime14parseExtraOptsEPcPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime15NewStringLatin1EP7_JNIEnvPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime15javaThreadShellEPv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime16createJavaThreadEPKcPFvPvES3_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime16toSlashClassNameEPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime18parseRuntimeOptionEPKcPcS2_S2_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime19javaCreateThreadEtcEPFiPvES1_PKcijPS1_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime19parseCompilerOptionEPKcPcS2_S2_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime21registerNativeMethodsEP7_JNIEnvPKcPK15JNINativeMethodi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime26parseCompilerRuntimeOptionEPKcPcS2_S2_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime4exitEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime5startEPKcRKNS_6VectorINS_7String8EEEb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime7startVmEPP7_JavaVMPP7_JNIEnvbb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime8callMainERKNS_7String8EP7_jclassRKNS_6VectorIS1_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime8setArgv0EPKcb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime8startRegEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime9addOptionEPKcPv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime9getJNIEnvEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntime9getJavaVMEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntimeC2EPcj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntimeD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14AndroidRuntimeD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14get_env_or_dieEP7_JavaVM);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android14init_FontUtilsEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15JHwRemoteBinder16GetNativeContextEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15JHwRemoteBinder16SetNativeContextEP7_JNIEnvP8_jobjectRKNS_2spIS0_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15JHwRemoteBinder9InitClassEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15JHwRemoteBinder9NewObjectEP7_JNIEnvRKNS_2spINS_8hardware7IBinderEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15JHwRemoteBinder9setBinderERKNS_2spINS_8hardware7IBinderEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15JHwRemoteBinderC2EP7_JNIEnvP8_jobjectRKNS_2spINS_8hardware7IBinderEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15JHwRemoteBinderD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15JHwRemoteBinderD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15MediaMetricsJNI20writeMetricsToBundleEP7_JNIEnvPNS_12mediametrics4ItemEP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15MediaMetricsJNI29nativeToJavaPersistableBundleEP7_JNIEnvPNS_2os17PersistableBundleE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android15getBPNativeDataEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16DeleteScreenshotEPvS0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage16allocStringArrayEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage20allocTemporaryStringEP7_JNIEnvP8_jstring);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage21allocTemporaryStorageEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage24allocTemporaryInt8VectorEP7_JNIEnvP11_jbyteArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage25allocTemporaryFloatVectorEP7_JNIEnvP12_jfloatArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage25allocTemporaryInt16VectorEP7_JNIEnvP12_jshortArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage25allocTemporaryInt32VectorEP7_JNIEnvP10_jintArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage25allocTemporaryInt64VectorEP7_JNIEnvP11_jlongArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage26allocTemporaryDoubleVectorEP7_JNIEnvP13_jdoubleArray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage26allocTemporaryNativeHandleEii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorage7releaseEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorageC2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16EphemeralStorageD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android16nullObjectReturnEPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android17AutoBufferPointerC2EP7_JNIEnvP8_jobjecth);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android17AutoBufferPointerD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android17CopyAssetToStreamEPNS_5AssetE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android17JNIDeviceCallback19onAudioDeviceUpdateEii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android17JNIDeviceCallbackC2EP7_JNIEnvP8_jobjectS4_P10_jmethodID);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android17JNIDeviceCallbackD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android17JNIDeviceCallbackD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18AssetStreamAdaptor4moveEl);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18AssetStreamAdaptor4readEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18AssetStreamAdaptor4seekEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18AssetStreamAdaptor6rewindEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18AssetStreamAdaptorC2EPNS_5AssetE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeInputChannel18setDisposeCallbackEPFvP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEEPvESA_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeInputChannel30invokeAndRemoveDisposeCallbackEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeInputChannelC2ERKNS_2spINS_12InputChannelEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeInputChannelD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueue11handleEventEiiPv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueue14raiseExceptionEP7_JNIEnvPKcP11_jthrowable);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueue23setFileDescriptorEventsEii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueue4wakeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueue8pollOnceEP7_JNIEnvP8_jobjecti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueueC1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueueC2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueueD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueueD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18NativeMessageQueueD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18forwardPdfiumErrorEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android18nativeGetPageCountEP7_JNIEnvP7_jclassx);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android19parcelForJavaObjectEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20VelocityTrackerState11addMovementEPKNS_11MotionEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20VelocityTrackerState11getVelocityEiPfS1_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20VelocityTrackerState12getEstimatorEiPNS_15VelocityTracker9EstimatorE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20VelocityTrackerState22computeCurrentVelocityEif);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20VelocityTrackerState5clearEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20VelocityTrackerStateC2EPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20ibinderForJavaObjectEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20javaObjectForIBinderEP7_JNIEnvRKNS_2spINS_7IBinderEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android20poly_clip_to_frustumEPNS_4PolyE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSender10initializeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSender11handleEventEiiPv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSender12sendKeyEventEjPKNS_8KeyEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSender15sendMotionEventEjPKNS_11MotionEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSender22receiveFinishedSignalsEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSender7disposeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSenderC1EP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEERKNS5_INS_12MessageQueueEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSenderC2EP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEERKNS5_INS_12MessageQueueEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSenderD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSenderD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22NativeInputEventSenderD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22createJavaParcelObjectEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22nativeScaleForPrintingEP7_JNIEnvP7_jclassx);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22poly_clip_to_halfspaceEPNS_4PolyES1_iff);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android22validateCanUseHwBinderERKNS_2spINS_8hardware7IBinderEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23JNIAudioAttributeHelper10makeUniqueEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23JNIAudioAttributeHelper12getJavaArrayEP7_JNIEnvPP13_jobjectArrayi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23JNIAudioAttributeHelper12nativeToJavaEP7_JNIEnvPP8_jobjectRK18audio_attributes_t);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23JNIAudioAttributeHelper14nativeFromJavaEP7_JNIEnvP8_jobjectP18audio_attributes_t);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23NativeInputWindowHandle10updateInfoEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23NativeInputWindowHandle31getInputWindowHandleObjLocalRefEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23NativeInputWindowHandleC2EP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23NativeInputWindowHandleD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23NativeInputWindowHandleD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23newParcelFileDescriptorEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23recycleJavaParcelObjectEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23signalExceptionForErrorEP7_JNIEnvP8_jobjectibi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23signalExceptionForErrorEP7_JNIEnvib);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23throw_sqlite3_exceptionEP7_JNIEnvP7sqlite3);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23throw_sqlite3_exceptionEP7_JNIEnvP7sqlite3PKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23throw_sqlite3_exceptionEP7_JNIEnvPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android23throw_sqlite3_exceptionEP7_JNIEnviPKcS3_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24HardwareRendererObserver13getNextBufferEP7_JNIEnvP11_jlongArrayPi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24HardwareRendererObserver6notifyEPKx);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24HardwareRendererObserverC2EP7_JavaVMP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24HardwareRendererObserverD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24HardwareRendererObserverD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24JNISurfaceTextureContext16onFrameAvailableERKNS_10BufferItemE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24JNISurfaceTextureContext9detachJNIEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24JNISurfaceTextureContext9getJNIEnvEPb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24JNISurfaceTextureContextC1EP7_JNIEnvP8_jobjectP7_jclass);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24JNISurfaceTextureContextC2EP7_JNIEnvP8_jobjectP7_jclass);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24JNISurfaceTextureContextD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24JNISurfaceTextureContextD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24JNISurfaceTextureContextD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiver10initializeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiver11handleEventEiiPv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiver11setFdEventsEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiver13consumeEventsEP7_JNIEnvbxPb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiver16finishInputEventEjb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiver7disposeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiverC1EP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEERKNS5_INS_12MessageQueueEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiverC2EP7_JNIEnvP8_jobjectRKNS_2spINS_12InputChannelEEERKNS5_INS_12MessageQueueEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiverD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiverD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android24NativeInputEventReceiverD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android25AssetManagerForJavaObjectEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android25register_android_os_DebugEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android25register_android_os_TraceEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android25register_android_util_LogEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26HwBinderDeathRecipientList3addERKNS_2spINS_22HwBinderDeathRecipientEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26HwBinderDeathRecipientList4findEP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26HwBinderDeathRecipientList4lockEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26HwBinderDeathRecipientList6removeERKNS_2spINS_22HwBinderDeathRecipientEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26HwBinderDeathRecipientListC2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26HwBinderDeathRecipientListD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26HwBinderDeathRecipientListD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiver13dispatchVsyncExyj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiver15dispatchHotplugExyb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiver21dispatchConfigChangedExyix);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiver7disposeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiverC1EP7_JNIEnvP8_jobjectRKNS_2spINS_12MessageQueueEEEii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiverC2EP7_JNIEnvP8_jobjectRKNS_2spINS_12MessageQueueEEEii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiverD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiverD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26NativeDisplayEventReceiverD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26SurfaceTexture_getProducerEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26audioEffectDescriptorClassEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26register_android_os_HwBlobEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android26register_android_os_ParcelEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android27JNIAudioVolumeGroupCallback13onServiceDiedEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android27JNIAudioVolumeGroupCallback25onAudioVolumeGroupChangedENS_14volume_group_tEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android27JNIAudioVolumeGroupCallbackC2EP7_JNIEnvP8_jobjectS4_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android27JNIAudioVolumeGroupCallbackD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android27JNIAudioVolumeGroupCallbackD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android27register_android_os_SELinuxEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28NativeInputApplicationHandle10updateInfoEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28NativeInputApplicationHandle36getInputApplicationHandleObjLocalRefEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28NativeInputApplicationHandleC2EP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28NativeInputApplicationHandleD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28NativeInputApplicationHandleD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28NdkAssetManagerForJavaObjectEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28register_android_os_HwBinderEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28register_android_os_HwParcelEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android28set_dalvik_blockguard_policyEP7_JNIEnvi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android29android_NativeActivity_finishEP15ANativeActivity);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android29android_view_KeyEvent_recycleEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android29android_view_PointerIcon_loadEP7_JNIEnvP8_jobjectS3_PNS_11PointerIconE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android29register_android_app_ActivityEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android29register_android_view_SurfaceEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android2spINS_10AudioTrackEEaSEPS1_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android2spINS_11AudioRecordEEaSEPS1_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android30AssetManagerForNdkAssetManagerEP13AAssetManager);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android30android_view_KeyEvent_toNativeEP7_JNIEnvP8_jobjectPNS_8KeyEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android30register_android_graphics_PathEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android30register_android_os_HidlMemoryEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android30register_android_os_MemoryFileEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android30register_android_util_EventLogEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android30register_android_util_StatsLogEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android30register_android_view_KeyEventEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31android_view_InputDevice_createEP7_JNIEnvRKNS_15InputDeviceInfoE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31android_view_Surface_getSurfaceEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31convertMicrophoneInfoFromNativeEP7_JNIEnvPP8_jobjectPKNS_5media14MicrophoneInfoE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31register_android_graphics_PaintEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31register_android_opengl_classesEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31register_android_os_HidlSupportEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31register_android_os_SystemClockEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31register_android_os_VintfObjectEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android31throw_sqlite3_exception_errcodeEP7_JNIEnviPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32CameraMetadata_getNativeMetadataEP7_JNIEnvP8_jobjectPNS_14CameraMetadataE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32SurfaceTexture_getSurfaceTextureEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32android_view_KeyEvent_fromNativeEP7_JNIEnvPKNS_8KeyEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32android_view_MotionEvent_recycleEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_graphics_CanvasEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_graphics_MatrixEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_graphics_RegionEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_os_FileObserverEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_os_MessageQueueEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_os_NativeHandleEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_os_SharedMemoryEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_security_ScryptEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_text_HyphenatorEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_util_PathParserEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_view_InputQueueEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android32register_android_view_RenderNodeEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33android_Configuration_getFromJavaEP7_JNIEnvP8_jobjectP14AConfiguration);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33android_view_Surface_isInstanceOfEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33register_android_content_XmlBlockEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33register_android_graphics_PictureEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33register_android_net_NetworkUtilsEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33register_android_view_InputDeviceEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33register_android_view_MotionEventEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33register_android_view_PointerIconEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android33register_android_view_TextureViewEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android34createAudioDeviceAddressFromNativeEP7_JNIEnvPP8_jobjectPKNS_19AudioDeviceTypeAddrE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android34register_android_os_HwRemoteBinderEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android34register_android_os_UEventObserverEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android34register_android_view_InputChannelEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android34register_android_view_TextureLayerEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android35android_SurfaceTexture_isInstanceOfEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android35android_graphics_Matrix_getSkMatrixEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android35android_view_KeyCharacterMap_createEP7_JNIEnviRKNS_2spINS_15KeyCharacterMapEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android35register_android_app_ActivityThreadEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android35register_android_app_NativeActivityEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android35register_android_media_MediaMetricsEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36android_NativeActivity_hideSoftInputEP15ANativeActivityi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36android_NativeActivity_showSoftInputEP15ANativeActivityi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36android_os_Debug_getDeathObjectCountEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36android_os_Debug_getLocalObjectCountEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36android_os_Debug_getProxyObjectCountEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36android_util_Log_isVerboseLogEnabledEPKc);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36android_view_Surface_getNativeWindowEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_content_StringBlockEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_graphics_ColorSpaceEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_graphics_DrawFilterEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_graphics_FontFamilyEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_graphics_fonts_FontEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_media_RemoteDisplayEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_net_LocalSocketImplEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_os_SystemPropertiesEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_os_VintfRuntimeInfoEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_util_MemoryIntArrayEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_view_SurfaceControlEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android36register_android_view_SurfaceSessionEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37android_NativeActivity_setWindowFlagsEP15ANativeActivityii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37android_view_MotionEvent_getNativePtrEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37android_view_MotionEvent_obtainAsCopyEP7_JNIEnvPKNS_11MotionEventE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37android_view_SurfaceSession_getClientEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37register_android_content_AssetManagerEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37register_android_database_SQLiteDebugEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37register_android_graphics_ColorFilterEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37register_android_graphics_PathMeasureEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37register_android_view_KeyCharacterMapEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android37register_android_view_VelocityTrackerEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38android_NativeActivity_setWindowFormatEP15ANativeActivityi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38android_view_PointerIcon_getLoadedIconEP7_JNIEnvP8_jobjectPNS_11PointerIconE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38android_view_PointerIcon_getSystemIconEP7_JNIEnvP8_jobjecti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38android_view_Surface_createFromSurfaceEP7_JNIEnvRKNS_2spINS_7SurfaceEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38convertAudioEffectDescriptorFromNativeEP7_JNIEnvPP8_jobjectPK19effect_descriptor_s);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_app_admin_SecurityLogEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_app_backup_FullBackupEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_content_res_ApkAssetsEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_database_CursorWindowEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_database_SQLiteGlobalEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_text_AndroidCharacterEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_util_StatsLogInternalEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_view_InputEventSenderEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android38register_android_view_ThreadedRendererEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39android_os_MessageQueue_getMessageQueueEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39android_view_PointerIcon_loadSystemIconEP7_JNIEnvP8_jobjectiPNS_11PointerIconE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39register_android_backup_BackupDataInputEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39register_android_content_res_ObbScannerEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39register_android_graphics_pdf_PdfEditorEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39register_android_os_GraphicsEnvironmentEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39register_android_util_jar_StrictJarFileEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39register_android_view_DisplayListCanvasEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39register_android_view_InputWindowHandleEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android39register_com_android_internal_os_ZygoteEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android40android_view_InputWindowHandle_getHandleEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android40register_android_backup_BackupDataOutputEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android40register_android_ddm_DdmHandleNativeHeapEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android40register_android_graphics_CanvasPropertyEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android40register_android_graphics_SurfaceTextureEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android40register_android_view_InputEventReceiverEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android40register_android_view_RenderNodeAnimatorEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android41android_view_InputChannel_getInputChannelEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android41register_android_graphics_pdf_PdfDocumentEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android41register_android_graphics_pdf_PdfRendererEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android42register_android_content_res_ConfigurationEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android42register_android_database_SQLiteConnectionEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android42register_android_graphics_BLASTBufferQueueEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android42register_android_graphics_fonts_FontFamilyEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android42register_android_graphics_text_LineBreakerEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android42register_android_service_DataLoaderServiceEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android42register_android_view_DisplayEventReceiverEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android43register_android_graphics_text_MeasuredTextEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android43register_com_android_internal_os_ZygoteInitEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android44android_view_InputChannel_setDisposeCallbackEP7_JNIEnvP8_jobjectPFvS1_S3_RKNS_2spINS_12InputChannelEEEPvES9_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android44convertAudioEffectDescriptorVectorFromNativeEP7_JNIEnvPP13_jobjectArrayRKNSt3__16vectorI19effect_descriptor_sNS5_9allocatorIS7_EEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android44register_android_backup_FileBackupHelperBaseEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android44register_android_view_InputApplicationHandleEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android44register_com_android_internal_os_FuseAppLoopEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android44register_com_android_internal_os_RuntimeInitEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android45android_view_InputApplicationHandle_getHandleEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android46register_android_backup_BackupHelperDispatcherEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android47register_android_animation_PropertyValuesHolderEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android49android_hardware_display_DisplayViewport_toNativeEP7_JNIEnvP8_jobjectPNS_15DisplayViewportE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android49register_android_graphics_drawable_VectorDrawableEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android49register_android_hardware_display_DisplayViewportEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android49register_android_view_CompositionSamplingListenerEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android50register_android_graphics_HardwareRendererObserverEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android50register_android_os_incremental_IncrementalManagerEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android51register_com_android_internal_os_ClassLoaderFactoryEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android52android_hardware_HardwareBuffer_convertToPixelFormatEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android52register_com_android_internal_util_VirtualRefBasePtrEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android53android_view_Surface_createFromIGraphicBufferProducerEP7_JNIEnvRKNS_2spINS_22IGraphicBufferProducerEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android53register_android_server_NetworkManagementSocketTaggerEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android54android_graphics_GraphicBuffer_getNativeGraphicsBufferEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android54android_hardware_HardwareBuffer_convertFromPixelFormatEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android55android_hardware_HardwareBuffer_getNativeHardwareBufferEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android56android_graphics_GraphicBuffer_createFromAHardwareBufferEP7_JNIEnvP15AHardwareBuffer);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android57android_hardware_HardwareBuffer_convertToGrallocUsageBitsEy);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android57android_hardware_HardwareBuffer_createFromAHardwareBufferEP7_JNIEnvP15AHardwareBuffer);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android57register_android_graphics_drawable_AnimatedVectorDrawableEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android57register_com_android_internal_content_NativeLibraryHelperEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android5vintf9to_stringINS0_13KernelVersionEEENSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android5vintf9to_stringINS0_7VersionEEENSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android60register_com_android_internal_os_ZygoteInit_nativeZygoteInitEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android6bitmap10toSkBitmapExP8SkBitmap);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android6bitmap12createBitmapEP7_JNIEnvPNS_6BitmapEiP11_jbyteArrayP8_jobjecti);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android6bitmap12reinitBitmapEP7_JNIEnvP8_jobjectRK11SkImageInfob);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android6bitmap8toBitmapEx);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android76register_com_android_internal_view_animation_NativeInterpolatorFactoryHelperEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob16GetNativeContextEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob16SetNativeContextEP7_JNIEnvP8_jobjectRKNS_2spIS0_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob16specializeBlobToENS0_8BlobTypeE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob4dataEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob5setToEPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob5writeEjPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob7putBlobEjRKNS_2spIS0_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob9InitClassEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob9NewObjectEP7_JNIEnvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlob9NewObjectEP7_JNIEnvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlobC2EP7_JNIEnvP8_jobjectj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlobD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7JHwBlobD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7Picture12endRecordingEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7Picture14beginRecordingEii);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7Picture16CreateFromStreamEP8SkStream);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7Picture4drawEPNS_6CanvasE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7PictureC2EO5sk_spI9SkPictureE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android7PictureC2EPKS0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android8getBlockEPvmPhm);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android8hardware10fromBinderINS_4hidl4base4V1_05IBaseENS4_8BpHwBaseENS4_8BnHwBaseEEENS_2spIT_EERKNS8_INS0_7IBinderEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinder10onTransactEjRKNS_8hardware6ParcelEPS2_jNSt3__18functionIFvRS2_EEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinder15GetNativeBinderEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinder16SetNativeContextEP7_JNIEnvP8_jobjectRKNS_2spINS_15JHwBinderHolderEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinder9InitClassEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinderC1EP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinderC2EP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinderD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinderD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwBinderD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel10getStorageEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel16GetNativeContextEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel16SetNativeContextEP7_JNIEnvP8_jobjectRKNS_2spIS0_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel19setTransactCallbackENSt3__18functionIFvRNS_8hardware6ParcelEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel4sendEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel9InitClassEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel9NewObjectEP7_JNIEnv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel9getParcelEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcel9setParcelEPNS_8hardware6ParcelEb);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcelC2EP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcelD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9JHwParcelD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils10TiffWriter8addEntryIdEEitjPKT_j);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils10TiffWriter8addEntryIhEEitjPKT_j);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils10TiffWriter8addEntryIiEEitjPKT_j);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils10TiffWriter8addEntryIjEEitjPKT_j);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils10TiffWriter8addEntryItEEitjPKT_j);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplIdED0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplIdED2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplIhED0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplIhED2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplIiED0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplIiED2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplIjED0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplIjED2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplItED0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN7android9img_utils13TiffEntryImplItED2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN8GIFMovie11onGetBitmapEP8SkBitmap);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN8GIFMovie9onGetInfoEPN5Movie4InfoE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN8GIFMovie9onSetTimeEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN8GIFMovieC2EP8SkStream);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN8GIFMovieD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZN8GIFMovieD2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext10getGpsDataEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext10hasGpsDataEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext12getThumbnailEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext12hasThumbnailEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext14getCaptureTimeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext14getDescriptionEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext14getOrientationEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext14hasCaptureTimeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext14hasDescriptionEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext17getThumbnailWidthEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext18getCharacteristicsEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext18getThumbnailHeightEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK13NativeContext9getResultEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK15NinePatchPeeker10getPaddingEP7_JNIEnvP8_jobject);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK15NinePatchPeeker21createNinePatchInsetsEP7_JNIEnvf);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK16InputStripSource6getIfdEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK16JNICameraContext33isRawImageCallbackBufferAvailableEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK17DirectStripSource6getIfdEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK18FileDescriptorInfo12DetachSocketERKNSt3__18functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK18FileDescriptorInfo14ReopenOrDetachERKNSt3__18functionIFvNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK18FileDescriptorInfo16RefersToSameFileEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK23FileDescriptorWhitelist9IsAllowedERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android10AxisHelper13getStyleValueEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android10AxisHelper6getTagEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android10ListHelper3getEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android10ListHelper4sizeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_12DisplayStateEE10do_compareEPKvS4_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_12DisplayStateEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_12DisplayStateEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_12DisplayStateEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_12DisplayStateEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_12DisplayStateEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_12DisplayStateEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE10do_compareEPKvS6_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorINS_16key_value_pair_tINS_7String8ES2_EEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP26audiotrack_callback_cookieE10do_compareEPKvS5_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP26audiotrack_callback_cookieE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP26audiotrack_callback_cookieE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP26audiotrack_callback_cookieE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP26audiotrack_callback_cookieE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP26audiotrack_callback_cookieE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP26audiotrack_callback_cookieE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP27audiorecord_callback_cookieE10do_compareEPKvS5_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP27audiorecord_callback_cookieE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP27audiorecord_callback_cookieE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP27audiorecord_callback_cookieE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP27audiorecord_callback_cookieE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP27audiorecord_callback_cookieE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android12SortedVectorIP27audiorecord_callback_cookieE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android15JHwRemoteBinder21getDeathRecipientListEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android15JHwRemoteBinder9getBinderEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android18AssetStreamAdaptor11getPositionEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android18AssetStreamAdaptor11hasPositionEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android18AssetStreamAdaptor11onDuplicateEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android18AssetStreamAdaptor7isAtEndEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android18AssetStreamAdaptor9getLengthEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorI12JavaVMOptionE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorI12JavaVMOptionE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorI12JavaVMOptionE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorI12JavaVMOptionE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorI12JavaVMOptionE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorI12JavaVMOptionE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_11DisplayInfoEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_11DisplayInfoEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_11DisplayInfoEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_11DisplayInfoEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_11DisplayInfoEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_11DisplayInfoEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_13PointerCoordsEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_13PointerCoordsEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_13PointerCoordsEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_13PointerCoordsEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_13PointerCoordsEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_13PointerCoordsEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16EphemeralStorage4ItemEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16EphemeralStorage4ItemEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16EphemeralStorage4ItemEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16EphemeralStorage4ItemEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16EphemeralStorage4ItemEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16EphemeralStorage4ItemEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_16key_value_pair_tIPNS_10InputEventEbEEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_17PointerPropertiesEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_17PointerPropertiesEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_17PointerPropertiesEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_17PointerPropertiesEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_17PointerPropertiesEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_17PointerPropertiesEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_19AudioDeviceTypeAddrEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_19AudioDeviceTypeAddrEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_19AudioDeviceTypeAddrEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_19AudioDeviceTypeAddrEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_19AudioDeviceTypeAddrEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_19AudioDeviceTypeAddrEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_22AudioMixMatchCriterionEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_22AudioMixMatchCriterionEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_22AudioMixMatchCriterionEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_22AudioMixMatchCriterionEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_22AudioMixMatchCriterionEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_22AudioMixMatchCriterionEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_24NativeInputEventReceiver6FinishEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_6SensorEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_6SensorEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_6SensorEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_6SensorEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_6SensorEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_6SensorEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7JHwBlob8BlobInfoEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7JHwBlob8BlobInfoEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7JHwBlob8BlobInfoEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7JHwBlob8BlobInfoEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7JHwBlob8BlobInfoEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7JHwBlob8BlobInfoEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7String8EE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7String8EE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7String8EE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7String8EE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7String8EE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_7String8EE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8AudioMixEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8AudioMixEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8AudioMixEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8AudioMixEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8AudioMixEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8AudioMixEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8KeyEventEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8KeyEventEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8KeyEventEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8KeyEventEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8KeyEventEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8KeyEventEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorINS_8hardware8graphics6common4V1_29ColorModeEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP11_jbyteArrayE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP11_jbyteArrayE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP11_jbyteArrayE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP11_jbyteArrayE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP11_jbyteArrayE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP11_jbyteArrayE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP14ScopedUtfCharsE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP14ScopedUtfCharsE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP14ScopedUtfCharsE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP14ScopedUtfCharsE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP14ScopedUtfCharsE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIP14ScopedUtfCharsE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_10InputEventEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_10InputEventEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_10InputEventEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_10InputEventEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_10InputEventEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_10InputEventEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_6LooperEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_6LooperEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_6LooperEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_6LooperEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_6LooperEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_6LooperEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_9img_utils11StripSourceEE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_9img_utils11StripSourceEE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_9img_utils11StripSourceEE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_9img_utils11StripSourceEE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_9img_utils11StripSourceEE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIPNS_9img_utils11StripSourceEE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIdE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIdE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIdE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIdE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIdE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIdE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIfE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIfE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIfE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIfE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIfE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIfE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIhE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIhE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIhE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIhE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIhE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIhE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIiE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIiE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIiE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIiE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIiE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIiE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIjE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIjE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIjE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIjE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIjE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIjE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorItE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorItE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorItE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorItE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorItE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorItE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIxE10do_destroyEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIxE12do_constructEPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIxE15do_move_forwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIxE16do_move_backwardEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIxE7do_copyEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android6VectorIxE8do_splatEPvPKvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob13writeToParcelEPNS_8hardware6ParcelE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob21writeEmbeddedToParcelEPNS_8hardware6ParcelEjj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob21writeSubBlobsToParcelEPNS_8hardware6ParcelEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob4dataEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob4readEjPvj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob4sizeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob4typeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob9getHandleEPj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7JHwBlob9getStringEjPPKNS_8hardware11hidl_stringE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7Picture15makePartialCopyEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7Picture5widthEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7Picture6heightEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android7Picture9serializeEP9SkWStream);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9JHwParcel7wasSentEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils10TiffWriter10buildEntryIdEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils10TiffWriter10buildEntryIhEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils10TiffWriter10buildEntryIiEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils10TiffWriter10buildEntryIjEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils10TiffWriter10buildEntryItEEitjPKT_PNS_2spINS0_9TiffEntryEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE12writeTagInfoEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE13getDataHelperEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE13getEndiannessEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE18getComparableValueEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE6getTagEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE7getSizeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE7getTypeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE8getCountEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIdE9writeDataEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE12writeTagInfoEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE13getDataHelperEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE13getEndiannessEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE18getComparableValueEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE6getTagEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE7getSizeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE7getTypeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE8getCountEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIhE9writeDataEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE12writeTagInfoEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE13getDataHelperEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE13getEndiannessEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE18getComparableValueEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE6getTagEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE7getSizeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE7getTypeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE8getCountEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIiE9writeDataEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE12writeTagInfoEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE13getDataHelperEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE13getEndiannessEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE18getComparableValueEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE6getTagEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE7getSizeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE7getTypeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE8getCountEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplIjE9writeDataEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE12writeTagInfoEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE13getDataHelperEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE13getEndiannessEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE18getComparableValueEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE6getTagEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE7getSizeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE7getTypeEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE8getCountEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNK7android9img_utils13TiffEntryImplItE9writeDataEjPNS0_12EndianOutputE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7__cloneEPNS0_6__baseIST_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7__cloneEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7__cloneEPNS0_6__baseIST_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7__cloneEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EE7__cloneEPNS0_6__baseISR_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EE7__cloneEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__112__hash_tableINS_17__hash_value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_22__unordered_map_hasherIS7_S8_NS_4hashIS7_EELb1EEENS_21__unordered_map_equalIS7_S8_NS_8equal_toIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__hash_const_iteratorIPNS_11__hash_nodeIS8_PvEEEERKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNKSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE18destroy_deallocateEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7destroyEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RA5_S5_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EEclEOSE_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE18destroy_deallocateEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EE7destroyEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_RS6_RS8_RKNS_12placeholders4__phILi1EEEEEENSC_ISR_EEFvSE_EEclEOSE_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EE18destroy_deallocateEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EE7destroyEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__110__function6__funcINS_6__bindIRFvP7_JNIEnvPKcP8_jstringRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEJRS4_S6_DnRKNS_12placeholders4__phILi1EEEEEENSC_ISP_EEFvSE_EEclEOSE_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableIN7android2spINS1_7IBinderEEENS1_16ISurfaceComposer6SpHashIS3_EENS_8equal_toIS4_EENS_9allocatorIS4_EEE25__emplace_unique_key_argsIS4_JS4_EEENS_4pairINS_15__hash_iteratorIPNS_11__hash_nodeIS4_PvEEEEbEERKT_DpOT0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableIN7android2spINS1_7IBinderEEENS1_16ISurfaceComposer6SpHashIS3_EENS_8equal_toIS4_EENS_9allocatorIS4_EEE6rehashEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableIN7android2spINS1_7IBinderEEENS1_16ISurfaceComposer6SpHashIS3_EENS_8equal_toIS4_EENS_9allocatorIS4_EEE8__rehashEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIN7minikin12MinikinPaintEjEENS_22__unordered_map_hasherIS3_S4_NS2_12LayoutPieces11PaintHasherELb1EEENS_21__unordered_map_equalIS3_S4_NS_8equal_toIS3_EELb1EEENS_9allocatorIS4_EEED2Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE25__emplace_unique_key_argsIiJRKNS_21piecewise_construct_tENS_5tupleIJRKiEEENSK_IJEEEEEENS_4pairINS_15__hash_iteratorIPNS_11__hash_nodeIS4_PvEEEEbEERKT_DpOT0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE25__emplace_unique_key_argsIiJRKNS_4pairIKiS3_EEEEENSH_INS_15__hash_iteratorIPNS_11__hash_nodeIS4_PvEEEEbEERKT_DpOT0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE6rehashEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE6removeENS_21__hash_const_iteratorIPNS_11__hash_nodeIS4_PvEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiP18FileDescriptorInfoEENS_22__unordered_map_hasherIiS4_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS4_NS_8equal_toIiEELb1EEENS_9allocatorIS4_EEE8__rehashEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiiEENS_22__unordered_map_hasherIiS2_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS2_NS_8equal_toIiEELb1EEENS_9allocatorIS2_EEE25__emplace_unique_key_argsIiJNS_4pairIiiEEEEENSF_INS_15__hash_iteratorIPNS_11__hash_nodeIS2_PvEEEEbEERKT_DpOT0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiiEENS_22__unordered_map_hasherIiS2_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS2_NS_8equal_toIiEELb1EEENS_9allocatorIS2_EEE25__emplace_unique_key_argsIiJRKNS_4pairIKiiEEEEENSF_INS_15__hash_iteratorIPNS_11__hash_nodeIS2_PvEEEEbEERKT_DpOT0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiiEENS_22__unordered_map_hasherIiS2_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS2_NS_8equal_toIiEELb1EEENS_9allocatorIS2_EEE6rehashEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIiiEENS_22__unordered_map_hasherIiS2_NS_4hashIiEELb1EEENS_21__unordered_map_equalIiS2_NS_8equal_toIiEELb1EEENS_9allocatorIS2_EEE8__rehashEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIjjEENS_22__unordered_map_hasherIjS2_NS_4hashIjEELb1EEENS_21__unordered_map_equalIjS2_NS_8equal_toIjEELb1EEENS_9allocatorIS2_EEE25__emplace_unique_key_argsIjJRjSF_EEENS_4pairINS_15__hash_iteratorIPNS_11__hash_nodeIS2_PvEEEEbEERKT_DpOT0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIjjEENS_22__unordered_map_hasherIjS2_NS_4hashIjEELb1EEENS_21__unordered_map_equalIjS2_NS_8equal_toIjEELb1EEENS_9allocatorIS2_EEE6rehashEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIjjEENS_22__unordered_map_hasherIjS2_NS_4hashIjEELb1EEENS_21__unordered_map_equalIjS2_NS_8equal_toIjEELb1EEENS_9allocatorIS2_EEE6removeENS_21__hash_const_iteratorIPNS_11__hash_nodeIS2_PvEEEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__112__hash_tableINS_17__hash_value_typeIjjEENS_22__unordered_map_hasherIjS2_NS_4hashIjEELb1EEENS_21__unordered_map_equalIjS2_NS_8equal_toIjEELb1EEENS_9allocatorIS2_EEE8__rehashEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__113__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__114__split_bufferINS_17basic_string_viewIcNS_11char_traitsIcEEEERNS_9allocatorIS4_EEE9push_backEOS4_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekoffExNS_8ios_base7seekdirEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE8overflowEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9pbackfailEi);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9underflowEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__120__shared_ptr_emplaceIN7android14CameraMetadataENS_9allocatorIS2_EEE16__on_zero_sharedEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__120__shared_ptr_emplaceIN7android14CameraMetadataENS_9allocatorIS2_EEE21__on_zero_shared_weakEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__120__shared_ptr_emplaceIN7android15MinikinFontSkiaENS_9allocatorIS2_EEE16__on_zero_sharedEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__120__shared_ptr_emplaceIN7android15MinikinFontSkiaENS_9allocatorIS2_EEE21__on_zero_shared_weakEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__120__shared_ptr_emplaceIN7android16JGlobalRefHolderENS_9allocatorIS2_EEE16__on_zero_sharedEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__120__shared_ptr_emplaceIN7android16JGlobalRefHolderENS_9allocatorIS2_EEE21__on_zero_shared_weakEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__120__shared_ptr_emplaceIN7minikin10FontFamilyENS_9allocatorIS2_EEE16__on_zero_sharedEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__120__shared_ptr_emplaceIN7minikin10FontFamilyENS_9allocatorIS2_EEE21__on_zero_shared_weakEv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__127__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeIN7android15ResTable_configENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_10shared_ptrIN7minikin14FontCollectionEEEEENS_19__map_value_compareIS7_SC_NS_4lessIS7_EELb1EEENS5_ISC_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEERPNS_15__tree_end_nodeISN_EERKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEERPNS_15__tree_end_nodeISJ_EESK_RKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEERPNS_15__tree_end_nodeISJ_EERKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE30__emplace_hint_unique_key_argsIS7_JRKNS_4pairIKS7_S7_EEEEENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEENS_21__tree_const_iteratorIS8_SP_iEERKT_DpOT0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeINS_17basic_string_viewIcNS_11char_traitsIcEEEEyEENS_19__map_value_compareIS5_S6_NS_4lessIS5_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIf7SkPointEENS_19__map_value_compareIfS3_NS_4lessIfEELb1EEENS_9allocatorIS3_EEE12__find_equalIfEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEERPNS_15__tree_end_nodeISF_EESG_RKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIf7SkPointEENS_19__map_value_compareIfS3_NS_4lessIfEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIffEENS_19__map_value_compareIfS2_NS_4lessIfEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIiNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEENS_19__map_value_compareIiS8_NS_4lessIiEELb1EEENS5_IS8_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEERPNS_15__tree_end_nodeISJ_EESK_RKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIiNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEENS_19__map_value_compareIiS8_NS_4lessIiEELb1EEENS5_IS8_EEE30__emplace_hint_unique_key_argsIiJRKNS_4pairIKiS7_EEEEENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEENS_21__tree_const_iteratorIS8_SP_iEERKT_DpOT0_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIiNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEENS_19__map_value_compareIiS8_NS_4lessIiEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIiNS_6vectorIN7android15AudioAttributesENS_9allocatorIS4_EEEEEENS_19__map_value_compareIiS8_NS_4lessIiEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIiPKcEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIifEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIixEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIyNS_10unique_ptrI14ScopedLocalRefIP11_jbyteArrayENS_14default_deleteIS6_EEEEEENS_19__map_value_compareIySA_NS_4lessIyEELb1EEENS_9allocatorISA_EEE5eraseENS_21__tree_const_iteratorISA_PNS_11__tree_nodeISA_PvEEiEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12__value_typeIyNS_10unique_ptrI14ScopedLocalRefIP11_jbyteArrayENS_14default_deleteIS6_EEEEEENS_19__map_value_compareIySA_NS_4lessIyEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS6_PNS_11__tree_nodeIS6_SD_EEiEERPNS_15__tree_end_nodeISF_EESG_RKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEERPNS_15__tree_end_nodeISF_EERKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeIiNS_4lessIiEENS_9allocatorIiEEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS8_EEiEERPNS_15__tree_end_nodeISA_EESB_RKT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorI11sock_filterNS_9allocatorIS1_EEE21__push_back_slow_pathIRKS1_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorI11sock_filterNS_9allocatorIS1_EEE21__push_back_slow_pathIS1_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorI18audio_attributes_tNS_9allocatorIS1_EEEC2ERKS4_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorI19audio_stream_type_tNS_9allocatorIS1_EEEC2ERKS4_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorI7SkPointNS_9allocatorIS1_EEE21__push_back_slow_pathIRKS1_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorI7SkPointNS_9allocatorIS1_EEE21__push_back_slow_pathIS1_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN15SkFontArguments4AxisEN7android10uirenderer18InlineStdAllocatorIS2_Lj2EEEE24__emplace_back_slow_pathIJS2_EEEvDpOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN15SkFontArguments4AxisEN7android10uirenderer18InlineStdAllocatorIS2_Lj2EEEE7reserveEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7android10dmabufinfo9DmaBufferENS_9allocatorIS3_EEE24__emplace_back_slow_pathIJRmyiRA10_KcSB_EEEvDpOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7android10dmabufinfo9DmaBufferENS_9allocatorIS3_EEE24__emplace_back_slow_pathIJRyyS8_RNS_12basic_stringIcNS_11char_traitsIcEENS4_IcEEEESE_EEEvDpOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7android10dmabufinfo9DmaBufferENS_9allocatorIS3_EEE24__emplace_back_slow_pathIJmRyS8_RPcPKcEEEvDpOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7android15AudioAttributesENS_9allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7android2spINS1_22HwBinderDeathRecipientEEENS_9allocatorIS4_EEE21__push_back_slow_pathIRKS4_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7android8graphics6BitmapENS_9allocatorIS3_EEE8__appendEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7minikin13FontVariationENS_9allocatorIS2_EEE21__push_back_slow_pathIS2_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7minikin13FontVariationENS_9allocatorIS2_EEE24__emplace_back_slow_pathIJjRfEEEvDpOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7minikin4FontENS_9allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIN7minikin4FontENS_9allocatorIS2_EEE21__push_back_slow_pathIS2_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorINS_10shared_ptrIN7minikin10FontFamilyEEENS_9allocatorIS4_EEE24__emplace_back_slow_pathIJRS4_EEEvDpOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorINS_10shared_ptrIN7minikin10FontFamilyEEENS_9allocatorIS4_EEE7reserveEj);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorINS_10unique_ptrI14ScopedUtfCharsNS_14default_deleteIS2_EEEENS_9allocatorIS5_EEE21__push_back_slow_pathIS5_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorINS_10unique_ptrIN7minikin3RunENS_14default_deleteIS3_EEEENS_9allocatorIS6_EEE24__emplace_back_slow_pathIJNS1_INS2_14ReplacementRunENS4_ISB_EEEEEEEvDpOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorINS_10unique_ptrIN7minikin3RunENS_14default_deleteIS3_EEEENS_9allocatorIS6_EEE24__emplace_back_slow_pathIJNS1_INS2_8StyleRunENS4_ISB_EEEEEEEvDpOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIRKS6_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIS6_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorINS_17basic_string_viewIcNS_11char_traitsIcEEEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EEOS4_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIP13native_handleNS_9allocatorIS2_EEEC2ERKS5_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIP14ScopedUtfCharsNS_9allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIPKN7android9ApkAssetsENS_9allocatorIS4_EEE21__push_back_slow_pathIS4_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIPKN7android9ApkAssetsENS_9allocatorIS4_EEEC2ERKS7_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIPKcNS_9allocatorIS2_EEE21__push_back_slow_pathIS2_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIPN7android10PageRecordENS_9allocatorIS3_EEE21__push_back_slow_pathIRKS3_EEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIcNS_9allocatorIcEEE6assignIPcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIcNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIRKfEEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIfEEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIfNS_9allocatorIfEEE6assignIPfEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIfNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIfNS_9allocatorIfEEE6insertIPfEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIfNS_15iterator_traitsIS7_E9referenceEEE5valueENS_11__wrap_iterIS5_EEE4typeENSB_IPKfEES7_S7_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIfNS_9allocatorIfEEEC2ERKS3_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIRKiEEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIiEEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIiNS_9allocatorIiEEE6insertINS_11__wrap_iterIPiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS9_E9referenceEEE5valueES7_E4typeENS5_IPKiEES9_S9_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIiNS_9allocatorIiEEE6insertIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS7_E9referenceEEE5valueENS_11__wrap_iterIS5_EEE4typeENSB_IPKiEES7_S7_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIjEEvOT_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIjNS_9allocatorIjEEE6assignIPjEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__16vectorIjNS_9allocatorIjEEEC2ERKS3_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__17getlineIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_13basic_istreamIT_T0_EES9_RNS_12basic_stringIS6_S7_T1_EES6_);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZNSt3__1lsIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_13basic_ostreamIT_T0_EES9_RKNS_12basic_stringIS6_S7_T1_EE);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZThn8_N7android18NativeMessageQueue11handleEventEiiPv);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZThn8_N7android18NativeMessageQueueD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZThn8_N7android18NativeMessageQueueD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android10InputQueueD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android10InputQueueD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android12MessageQueueD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android12MessageQueueD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android18NativeMessageQueueD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android18NativeMessageQueueD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android22NativeInputEventSenderD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android22NativeInputEventSenderD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android24JNISurfaceTextureContextD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android24JNISurfaceTextureContextD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android24NativeInputEventReceiverD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android24NativeInputEventReceiverD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android26NativeDisplayEventReceiverD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android26NativeDisplayEventReceiverD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android9JHwBinderD0Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", _ZTv0_n12_N7android9JHwBinderD1Ev);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_fatal_no_abort);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_fatal_va_list);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_format_buffer);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_format_buffer_va_list);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_format_fd);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_format_fd_va_list);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_format_log);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_format_log_va_list);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", async_safe_write_log);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", crypto_scrypt);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", init_android_graphics);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", note_log_drop);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", reallocarray);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", registerFrameworkNatives);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", register_android_graphics_classes);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", statd_writer_trylock);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", stats_log_close);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", statsd_writer_init_lock);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", statsd_writer_init_unlock);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", write_buffer_to_statsd);
  INIT_INTERCEPTABLE_STUB_FUNCTION("libandroid_runtime.so", zygote_preload_graphics);
}
// clang-format on
